#ifndef _IBHANDLE_
#define _IBHANDLE_
/*******************************************************************************
* FILE NAME: ibhandle.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IHandle                                                                  *
*     ISemaphoreHandle                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <ievtdata.hpp>

class ostream;
class IString;

#pragma pack(4)

class IHandle : public IBase {
typedef IBase
  Inherited;
public:
/*---------------------------------- Value -----------------------------------*/
#ifdef IC_WIN
typedef void*
  Value;
#endif
#ifdef IC_MOTIFPM
typedef unsigned long
  Value;
#endif

/*------------------------------- Constructors -------------------------------*/
  IHandle ( Value value );

/*------------------------------- Diagnostics --------------------------------*/

IString
  asString    ( ) const,
  asDebugInfo ( ) const;

friend ostream
 &operator << ( ostream&       aStream,
                const IHandle& aHandle );

unsigned long
  asUnsigned  ( ) const;

/*-------------------------------- Operators ---------------------------------*/
#ifndef IC_MOTIF
  operator Value ( ) const;
#endif

protected:
/*---------------------------------- Value -----------------------------------*/
Value
  handle;
}; // IHandle


class ISemaphoreHandle : public IHandle {
typedef IHandle
  Inherited;
public:
/*------------------------------- Constructors -------------------------------*/
  ISemaphoreHandle ( Value hsem = 0 );

/*-------------------------------- Operators ---------------------------------*/
#ifdef IC_MOTIF
  operator Value ( ) const;
#endif

}; // ISemaphoreHandle

#pragma pack()

#ifndef I_NO_INLINES
  #include <ibhandle.inl>
#endif

#endif // _IBHANDLE_
