/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#include <iexc.h>
#include <iexctxt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#define ICCEXCLASSIMPLEMENT(child,parent)\
  child :: child(const char* a, unsigned long b,\
                 Severity c)\
    : parent (a, b, c)\
        { }\
  char const* child :: name () const\
    { return (#child);\
    }\
  child :: ~child() {;}\
  child :: child(const child & a) : parent(a) {;}\
  void child :: operator= (child const&) {;}\
  void child :: throwIt (unsigned long msgID,\
              char const* fileName, unsigned long lineNumber)\
    { ICollectionExceptionText msgText (msgID); child exc (msgText);\
      exc.addLocation (IExceptionLocation (fileName, "", lineNumber));\
      exc.logExceptionData (); ITHROW (exc); }


ICCEXCLASSIMPLEMENT(IPreconditionViolation,IException);
  ICCEXCLASSIMPLEMENT(IFullException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IEmptyException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(INotEmptyException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(INotBoundedException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(ICursorInvalidException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IPositionInvalidException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(INotContainsKeyException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IKeyAlreadyExistsException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IRootAlreadyExistsException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IChildAlreadyExistsException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IIdenticalCollectionException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IInvalidReplacementException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(ICyclicAttachException,IPreconditionViolation);

  ICCEXCLASSIMPLEMENT(IOutOfCollectionMemory,IOutOfMemory);



#pragma info (restore)
#pragma pack ()
