/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#include <iiaks.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)


// ---
// IAKeySetImpl
// ---

// public members

IAKeySetImpl::
~IAKeySetImpl ()
{
}

// protected members

IAKeySetImpl::
IAKeySetImpl (Ops& ops)
: IACollectionImpl (ops)
{
}

IBoolean
IAKeySetImpl::
LocateNextElementWithKey (void const*, ICursorImpl& cursor) const
{ cursor.Invalidate ();
  return false;
}

INumber
IAKeySetImpl::
NumberOfDifferentKeys () const
{ return NumberOfElements ();
}

INumber
IAKeySetImpl::
NumberOfElementsWithKey (void const* key) const
{ if (ContainsElementWithKey (key))
    return 1;
  else
    return 0;
}

INumber
IAKeySetImpl::
RemoveAllElementsWithKey (void const* key)
{ if (RemoveElementWithKey (key))
    return 1;
  else
    return 0;
}

IBoolean
IAKeySetImpl::
SetToNextWithDifferentKey (ICursorImpl& cursor) const
{ return SetToNext (cursor);
}

#pragma info (restore)
#pragma pack ()
