/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIAKSS_H
#define _IIAKSS_H

#include <iiacllct.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif

class IAKeySortedSetImpl : public IACollectionImpl {
public:

          ~IAKeySortedSetImpl
                            ();

  virtual
  long     Compare          (IAKeySortedSetImpl const&,
                             ICompFunc, void*) const;

protected:

           IAKeySortedSetImpl
                            (Ops&);

  INumber  NumberOfDifferentKeys
                            () const;

  INumber  NumberOfElementsWithKey
                            (void const*) const;

  INumber  RemoveAllElementsWithKey
                            (void const*);

  IBoolean SetToNextWithDifferentKey
                            (ICursorImpl&) const;

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Compare          (IAKeySortedSetImpl const&,\
                             ICompFunc, void*) const,\
           IAKeySortedSetImpl\
                            (Ops&)\
                        )
#endif

};

#pragma SOMAsDefault (pop)

#pragma info (restore)
#pragma pack ()

#endif
