/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#include <iiatree.h>
#include <iiexc.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMDefine (ITreeCursorImpl)
#endif

// ----------
// IATreeImpl
// ----------

ICollectionExceptionText
IATreeImpl::cvExceptionText (IC_OUT_OF_COLLECTION_MEMORY);

// public members

void*
IATreeImpl::
CheckPointer (void* ptr)
{ if (ptr == 0) {
    throw IOutOfCollectionMemoryImpl (cvExceptionText);
  }
  return ptr;
}

void
IATreeImpl::
Delete ()
{ LockBeforeWriting ();
  if (--ivReferenceCount == 0) {
    delete ivOps; // quasimodo suicide
    return;       // ..thus, return as soon as possible
  }
  UnlockAfterWriting ();
}

void
IATreeImpl::
Initialize ()
{ LockBeforeWriting ();
  ivReferenceCount++;
  UnlockAfterWriting ();
}

IBoolean
IATreeImpl::
IsEmpty () const
{ return (NumberOfElements () == 0);
}

void
IATreeImpl::
LockBeforeReading (long)
{
}

void
IATreeImpl::
LockBeforeWriting (long)
{
}

void
IATreeImpl::
UnlockAfterReading ()
{
}

void
IATreeImpl::
UnlockAfterWriting ()
{
}

// ---------
// IATreeOps
// ---------

// public members

IATreeOps::
~IATreeOps ()
{
}

#pragma pack ()
#pragma info (restore)
