/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

// --------------------------
// IBagOnKeyBagMngCursorImpl
// --------------------------

// public members

template <class Base>
IBagOnKeyBagMngCursorImpl <Base>::
IBagOnKeyBagMngCursorImpl
  (IBagOnKeyBagImpl <Base> const& collection)
: Inherited (IBagOnKeyBagImpl <Base>::BaseOf (collection))
{ ivCollection = &collection;
}

template <class Base>
IBagOnKeyBagMngCursorImpl <Base>::
~IBagOnKeyBagMngCursorImpl ()
{
}

// ----------------
// IBagOnKeyBagImpl
// ----------------

// public members

template <class Base>
IBagOnKeyBagImpl <Base>::
IBagOnKeyBagImpl (Ops& ops, INumber)
: IABagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IBagOnKeyBagImpl <Base>::
IBagOnKeyBagImpl (Ops& ops, IBagOnKeyBagImpl <Base> const& collection)
: IABagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IBagOnKeyBagImpl <Base>::
~IBagOnKeyBagImpl ()
{
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
void
IBagOnKeyBagImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    BaseOf (*this).Base::AddAllFrom (BaseOf ((Self const&)collection));
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
IBagOnKeyBagImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
char const*
IBagOnKeyBagImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
IBagOnKeyBagImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
Contains (void const* element) const
{ return BaseOf (*this).Base::ContainsElementWithKey (element);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
ContainsAllFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    return BaseOf (*this).
      Base::ContainsAllKeysFrom (BaseOf ((Self const&)collection));
  }
  else
    return Inherited::ContainsAllFrom (collection);
}

template <class Base>
void
IBagOnKeyBagImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
IBagOnKeyBagImpl <Base>::Cursor*
IBagOnKeyBagImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
IBagOnKeyBagImpl <Base>::MngCursor*
IBagOnKeyBagImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
IBagOnKeyBagImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ return BaseOf (*this).LocateElementWithKey (element, cursor);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
LocateNext (void const* element, ICursorImpl& cursor) const
{ return BaseOf (*this).
    Base::LocateNextElementWithKey (element, cursor);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
INumber
IBagOnKeyBagImpl <Base>::
NumberOfDifferentElements () const
{ return BaseOf (*this).Base::NumberOfDifferentKeys ();
}

template <class Base>
INumber
IBagOnKeyBagImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
INumber
IBagOnKeyBagImpl <Base>::
NumberOfOccurrences (void const* element) const
{ return BaseOf (*this).Base::NumberOfElementsWithKey (element);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
Remove (void const* element)
{ return BaseOf (*this).Base::RemoveElementWithKey (element);
}

template <class Base>
INumber
IBagOnKeyBagImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
IBagOnKeyBagImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
INumber
IBagOnKeyBagImpl <Base>::
RemoveAllOccurrences (void const* element)
{ return BaseOf (*this).Base::RemoveAllElementsWithKey (element);
}

template <class Base>
void
IBagOnKeyBagImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
IBagOnKeyBagImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
SetToNextDifferentElement (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNextWithDifferentKey (cursor);
}

template <class Base>
IBoolean
IBagOnKeyBagImpl <Base>::
operator== (IABagImpl const& collection) const
{ return (Self::NumberOfElements () == collection.NumberOfElements () &&
          Self::ContainsAllFrom (collection));
}

template <class Base>
TStream&
IBagOnKeyBagImpl <Base>::
operator<<= (TStream& fromWhere)
{ return (BaseOf (*this) <<= fromWhere);
}

template <class Base>
TStream&
IBagOnKeyBagImpl <Base>::
operator>>= (TStream& toWhere) const
{ return (BaseOf (*this) >>= toWhere);
}

#pragma info (restore)
#pragma pack ()
