/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

// ----------------------------
// IHeapOnSequenceMngCursorImpl
// ----------------------------

// public members

template <class Base>
IHeapOnSequenceMngCursorImpl <Base>::
IHeapOnSequenceMngCursorImpl
  (IHeapOnSequenceImpl <Base> const& collection)
: Inherited (IHeapOnSequenceImpl <Base>::BaseOf (collection))
{ ivCollection = &collection;
}

template <class Base>
IHeapOnSequenceMngCursorImpl <Base>::
~IHeapOnSequenceMngCursorImpl ()
{
}

// -------------------
// IHeapOnSequenceImpl
// -------------------

// public members

template <class Base>
IHeapOnSequenceImpl <Base>::
IHeapOnSequenceImpl (Ops& ops, INumber)
: IAHeapImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IHeapOnSequenceImpl <Base>::
IHeapOnSequenceImpl (Ops& ops, IHeapOnSequenceImpl <Base> const&)
: IAHeapImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IHeapOnSequenceImpl <Base>::
~IHeapOnSequenceImpl ()
{
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    BaseOf (*this).Base::AddAllFrom (BaseOf ((Self const&)collection));
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
IHeapOnSequenceImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
char const*
IHeapOnSequenceImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
IHeapOnSequenceImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
IHeapOnSequenceImpl <Base>::Cursor*
IHeapOnSequenceImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
IHeapOnSequenceImpl <Base>::MngCursor*
IHeapOnSequenceImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
IHeapOnSequenceImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
INumber
IHeapOnSequenceImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
INumber
IHeapOnSequenceImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
IHeapOnSequenceImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
IBoolean
IHeapOnSequenceImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
TStream&
IHeapOnSequenceImpl <Base>::
operator<<= (TStream& fromWhere)
{ return (BaseOf (*this) <<= fromWhere);
}

template <class Base>
TStream&
IHeapOnSequenceImpl <Base>::
operator>>= (TStream& toWhere) const
{ return (BaseOf (*this) >>= toWhere);
}

#pragma info (restore)
#pragma pack ()
