/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

// -------------------------
// IKeySetOnKeySortedSetImpl
// -------------------------

// public members
#if defined (__LIB_BUILD__)

#if ! defined (__2nd_LEVEL__)
#define inline
#endif

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
AddOrReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).AddOrReplaceElementWithKey (element, cursor);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
inline void*
IKeySetOnKeySortedSetImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
inline char const*
IKeySetOnKeySortedSetImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ContainsElementWithKey (key);
}

template <class Base>
inline void*
IKeySetOnKeySortedSetImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
inline void*
IKeySetOnKeySortedSetImpl <Base>::
ElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ElementWithKey (key);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
inline void*
IKeySetOnKeySortedSetImpl <Base>::
Key (void const* element) const
{ return BaseOf (*this).Key (element);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
LocateElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (key, cursor);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
LocateOrAddElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
inline INumber
IKeySetOnKeySortedSetImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
inline INumber
IKeySetOnKeySortedSetImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
inline INumber
IKeySetOnKeySortedSetImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
inline void
IKeySetOnKeySortedSetImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
RemoveElementWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveElementWithKey (key);
}

template <class Base>
inline void
IKeySetOnKeySortedSetImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
ReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).ReplaceElementWithKey (element, cursor);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
inline TStream&
IKeySetOnKeySortedSetImpl <Base>::
operator<<= (TStream& fromWhere)
{ return (BaseOf (*this) <<= fromWhere);
}

template <class Base>
inline TStream&
IKeySetOnKeySortedSetImpl <Base>::
operator>>= (TStream& toWhere) const
{ return (BaseOf (*this) >>= toWhere);
}

#if ! defined (__2nd_LEVEL__)
#undef inline
#endif

#endif

template <class Base>
inline void
IKeySetOnKeySortedSetImpl <Base>::
operator= (IKeySetOnKeySortedSetImpl <Base> const& collection)
{ BaseOf (*this).Base::operator= (BaseOf (collection));
}
#if defined (__LIB_BUILD__)

// protected members

template <class Base>
inline IBoolean
IKeySetOnKeySortedSetImpl <Base>::
EqualKeys (void const* arg1, void const* arg2, IArgType argType) const
{ return (BaseOf (*this).CompareKeys (arg1, arg2, argType) == 0);
}

// private members

template <class Base>
inline Base&
IKeySetOnKeySortedSetImpl <Base>::
BaseOf (IKeySetOnKeySortedSetImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline IKeySetOnKeySortedSetImpl <Base>::Ops&
IKeySetOnKeySortedSetImpl <Base>::
OpsOf (IKeySetOnKeySortedSetImpl <Base> const& collection)
{ return (Ops&) Inherited::OpsOf (collection);
}
#endif

// -------------------------
// IAKeySetOnKeySortedSetOps
// -------------------------

// public members

template <class Base>
inline
IAKeySetOnKeySortedSetOps <Base>::
~IAKeySetOnKeySortedSetOps ()
{
}
