/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

// ------------------------------
// IRelationOnKeyBagMngCursorImpl
// ------------------------------

// public members

template <class Base>
IRelationOnKeyBagMngCursorImpl <Base>::
IRelationOnKeyBagMngCursorImpl
  (IRelationOnKeyBagImpl <Base> const& collection)
: Inherited (IRelationOnKeyBagImpl <Base>::BaseOf (collection))
{ ivCollection = &collection;
}

template <class Base>
IRelationOnKeyBagMngCursorImpl <Base>::
~IRelationOnKeyBagMngCursorImpl ()
{
}

// ---------------------
// IRelationOnKeyBagImpl
// ---------------------

// public members

template <class Base>
IRelationOnKeyBagImpl <Base>::
IRelationOnKeyBagImpl (Ops& ops, INumber)
: IARelationImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IRelationOnKeyBagImpl <Base>::
IRelationOnKeyBagImpl (Ops& ops, IRelationOnKeyBagImpl <Base> const&)
: IARelationImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IRelationOnKeyBagImpl <Base>::
~IRelationOnKeyBagImpl ()
{
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return ! Self::LocateOrAdd (element, cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
AddOrReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).AddOrReplaceElementWithKey (element, cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
IRelationOnKeyBagImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
char const*
IRelationOnKeyBagImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
IRelationOnKeyBagImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
Contains (void const* element) const
{ return Self::Locate (element, CursorOf (*this));
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
ContainsAllKeysFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& rel = (Self const&)collection;
    return BaseOf (*this).Base::ContainsAllKeysFrom (BaseOf (rel));
  }
  else
    return Inherited::ContainsAllKeysFrom (collection);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ContainsElementWithKey (key);
}

template <class Base>
void
IRelationOnKeyBagImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
IRelationOnKeyBagImpl <Base>::Cursor*
IRelationOnKeyBagImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
IRelationOnKeyBagImpl <Base>::MngCursor*
IRelationOnKeyBagImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
IRelationOnKeyBagImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
void*
IRelationOnKeyBagImpl <Base>::
ElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ElementWithKey (key);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
void*
IRelationOnKeyBagImpl <Base>::
Key (void const* element) const
{ return BaseOf (*this).Key (element);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ void const* key = Self::Key (element);
  for (Self::LocateElementWithKey (key, cursor);
       cursor.IsValid ();
       Self::LocateNextElementWithKey (key, cursor)) {
    if (EqualElements (Self::ElementAt (cursor), element))
      return true;
  }
  return false;
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
LocateElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (key, cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
LocateNextElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateNextElementWithKey (key, cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ IBoolean isContained = Self::Locate (element, cursor);

  if (! isContained) {
    BaseOf (*this).Base::Add (element, cursor);
  }

  return isContained;
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
LocateOrAddElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
INumber
IRelationOnKeyBagImpl <Base>::
NumberOfDifferentKeys () const
{ return BaseOf (*this).Base::NumberOfDifferentKeys ();
}

template <class Base>
INumber
IRelationOnKeyBagImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
INumber
IRelationOnKeyBagImpl <Base>::
NumberOfElementsWithKey (void const* key) const
{ return BaseOf (*this).Base::NumberOfElementsWithKey (key);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
Remove (void const* element)
{ IBoolean isContained = Self::Locate (element, CursorOf (*this));

  if (isContained)
    BaseOf (*this).Base::RemoveAt (CursorOf (*this));

  return isContained;
}

template <class Base>
INumber
IRelationOnKeyBagImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
IRelationOnKeyBagImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
INumber
IRelationOnKeyBagImpl <Base>::
RemoveAllElementsWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveAllElementsWithKey (key);
}

template <class Base>
void
IRelationOnKeyBagImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
RemoveElementWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveElementWithKey (key);
}

template <class Base>
void
IRelationOnKeyBagImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
ReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).ReplaceElementWithKey (element, cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
SetToNextWithDifferentKey (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNextWithDifferentKey (cursor);
}

template <class Base>
IBoolean
IRelationOnKeyBagImpl <Base>::
operator== (IARelationImpl const& collection) const
{ IBoolean result =
    Self::NumberOfElements () == collection.NumberOfElements ();
  if (result && this != &collection) {
    ICursorImpl& thisCursor = CursorOf (*this),
               & thatCursor = CursorOf (collection);
    for (Self::SetToFirst (thisCursor),
           collection.SetToFirst (thatCursor);
         result && thisCursor.IsValid ();
         Self::SetToNext (thisCursor),
           collection.SetToNext (thatCursor)) {
      result = EqualElements (Self::ElementAt (thisCursor),
                              collection.ElementAt (thatCursor));
    }
  }
  return result;
}

template <class Base>
TStream&
IRelationOnKeyBagImpl <Base>::
operator<<= (TStream& fromWhere)
{ return (BaseOf (*this) <<= OpsOf (*this) <<= fromWhere);
}

template <class Base>
TStream&
IRelationOnKeyBagImpl <Base>::
operator>>= (TStream& toWhere) const
{ return (BaseOf (*this) >>= OpsOf (*this) >>= toWhere);
}

#pragma info (restore)
#pragma pack ()
