/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IISBLST_H
#define _IISBLST_H

#include <iisbksb.h>

#if defined (__LIB_BUILD__)
#define __2nd_LEVEL__
#endif

#include <iiksblst.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif

typedef ISortedBagOnKeySortedBagImpl
         <IKeySortedBagAsListImpl> ISortedBagAsListImpl;

typedef IASortedBagOnKeySortedBagOps
          <IKeySortedBagAsListImpl> IASortedBagAsListOps;

template <class Element, class ElementOps, class Implementation>
class ISortedBagAsListOps :
  public IASortedBagAsListOps {

  typedef  IASortedBagAsListOps Inherited;

  typedef  ISortedBagAsListOps
            <Element, ElementOps, Implementation> Self;

  typedef  IKeySortedBagAsListOps
            <Element, Element, IOpsWithKey <Element, ElementOps>,
             IKeySortedBagAsListImpl > Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  void KeyType;

           ISortedBagAsListOps
                           (INumber);

           ISortedBagAsListOps
                           (INumber, void*);

           ISortedBagAsListOps
                           (ISortedBagAsListOps
                             <Element, ElementOps,
                              Implementation> const&);

          ~ISortedBagAsListOps
                           ();

  IACollectionImpl*
           Clone           () const;

           operator IKeySortedBagAsListImpl&
                           ();

           operator Implementation*
                           ();


protected:

private:

  Base     ivBase;

  Implementation
           ivImpl;

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__) 
#pragma SOMReleaseOrder (\
           ISortedBagAsListOps\
                            (INumber),\
           ISortedBagAsListOps\
                            (INumber, void*),\
           operator Implementation*\
                            ()\
                        )
#endif 

};

#pragma SOMAsDefault (pop)

#if ! defined (__TEMPINC__)
#include <iisblst.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
