#ifdef __MVS__
                   ??=ifdef __COMPILER_VER__
                     ??=pragma filetag("IBM-1047")
                   ??=endif
                   #pragma nomargins nosequence
                   #pragma checkout(suspend)
#endif

#ifndef _ISTRTEST_
#define _ISTRTEST_
/*******************************************************************************
* FILE NAME: istrtest.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IStringTest                                                              *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ivbase.hpp>

#pragma pack(4)

extern "C"
  {
#ifdef IC_PM
  typedef IBase::Boolean _Optlink ICStrTestFn( int );
#endif //IC_PM
#ifndef IC_PM
  typedef IBase::Boolean ICStrTestFn( int );
#endif //not IC_PM
  }


#if defined (__SOM_ENABLED__)
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

class IStringTest : public IVBase {
typedef IVBase
  Inherited;

public:

/*------------------------- Function Types -----------------------------------*/
typedef ICStrTestFn
  CFunction;
typedef Boolean
  CPPFunction( int );

/*------------------------- Constructors -------------------------------------*/
  IStringTest ( CFunction   &cFunc );
 ~IStringTest ( );

/*------------------------- Testing ------------------------------------------*/
virtual Boolean
  test        ( int c ) const;

protected:
/*------------------------- Test Function Description ------------------------*/
enum FnType {
  user,
  c,
  cpp,
  memFn,
  cMemFn
  };

FnType
  type;

union { CFunction *cFn; void *user; } data;

/*------------------------ Protected Constructors ----------------------------*/
  IStringTest ( FnType  type,
                void   *userData );

}; // class IStringTest

template < class T >
class IStringTestMemberFn : public IStringTest {
public:
/*------------------------- Function Types -----------------------------------*/
typedef Boolean
 ( T::*ConstFn )( int ) const;
typedef Boolean
 ( T::*NonconstFn )( int );

/*------------------------- Constructors -------------------------------------*/
  IStringTestMemberFn ( const T    &object,
                        ConstFn     constFn )
    : IStringTest ( user, (void*)&object ),
      cMF         ( constFn )
    {
    }
  IStringTestMemberFn ( T          &object,
                        NonconstFn  nonconstFn )
    : IStringTest ( user, (void*)&object ),
      ncMF        ( nonconstFn )
    {
    }

/*------------------------- Testing ------------------------------------------*/
virtual Boolean
  test                ( int c ) const
    {
    if ( this->type == cMemFn )
      return ((const T*)data.user->*cMF)( c );
    else
      return ((T*)data.user->*ncMF)( c );
    }

private:
/*------------------------------ Private ------------------------------------*/
union { ConstFn cMF; NonconstFn ncMF; };


#if 0
#if defined (__SOM_ENABLED__ ) && defined (__RRBC_LIB__)

#pragma SOMClassVersion  (*, 3, 0)

#pragma SOMReleaseOrder( \
/*   1 */       IStringTest(CFunction&),\
/*   2 */       test(int) const,\
/*   3 */       IStringTest(FnType,void*))

#endif    // SOM_ENABLED & RRBC_LIB
#endif

};


#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault (pop)
#endif

#pragma pack()

#ifndef I_NO_INLINES
  #include <istrtest.inl>
#endif

#endif // _ISTRTEST_


#ifdef __MVS__
                   #pragma checkout(resume)
#endif

