/*******************************************************************************
* FILE NAME: ivbase.cpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Implementation of the class IVBase, used when the derived class  has or    *
*   may have virtual functions (otherwise, derive from IBase).                 *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ivbase.hpp>

  #include <istring.hpp>

  #include <istream.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _IVBASE_CPP_
  #include <ipagetun.h>
#endif

IVBase ::  ~IVBase ( ) {}

ostream &operator << ( ostream      &aStream,
                       const IVBase &anObject )
  {
  return aStream << anObject.asString();
  }

IString IVBase :: asString ( ) const
  {
  return "IVBase object";
  }

IString IVBase :: asDebugInfo ( ) const
  {
  IString result = "IVBase(@";
  result += IString( (unsigned long)this ).d2x();
  result += ")";
  return result;
  }
