/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswDataManager 
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    Manage a IDataObject pointer.  Designed to be contained within a
 *    CAswContainedObject object.  Not a public class
 *
 *****************************************************************************/

#ifndef ASDATMGR_H
#define ASDATMGR_H
#include <aspack.h>
class CAswDataManager : public CAswBase
{
public:
   CAswDataManager(PASWCONTROL         pAswControl,
                   PASWCONTAINEDOBJECT pAswContainedObject);
   ~CAswDataManager(void);
   CAswResult Setup(void);
   virtual CAswResult Shutdown(BOOL fEmergency = FALSE);
   inline void AddDataSiteToList(PASWDATASITE pDataSite)
   { 
      m_lhListOfDataSites.Insert(pDataSite);
   }
   inline void RemoveDataSiteFromList(PASWDATASITE pDataSite)
   { 
      m_lhListOfDataSites.Remove(pDataSite);
   }
   inline PASWDATASITE GetFirstDataSite(void)
   {
      return m_lhListOfDataSites.GetFirst();
   }
   inline PASWDATASITE GetNextDataSite(void)
   {
      return m_lhListOfDataSites.GetNext();
   }
   virtual CAswResult ASWPUBMETHOD GetRefHolder(PASWREFHOLDER *ppRefHolder);
   virtual ASWREFIID ASWPUBMETHOD GetPreferredIID(void) const;
   CAswResult GetData(LPFORMATETC      pFormatEtc,
                      PASWSTGMEDUNION  pAswStgMedium,
                      PASWSTORAGE      pAswStorage = NULL,
                      PASWSTREAM       pAswStream = NULL);
   CAswResult GetDataHere(LPFORMATETC     pFormatEtc,
                          PASWSTGMEDUNION pAswStgMedium);
   CAswResult QueryGetData(LPFORMATETC pFormatEtc);
   CAswResult DAdvise(LPFORMATETC pFormatEtc, DWORD advf, LPDWORD pdwConnection);
   CAswResult DUnadvise(DWORD dwConnection);
   CAswResult SetAllAdvises(DWORD advf = ADVF_NODATA);
   CAswResult RemoveAllAdvises(void);
   void OnViewChange(DWORD dwAspect, LONG lindex);
   void OnDataChange(LPFORMATETC pFormatEtc, LPSTGMEDIUM pMedium);
   void OnRename(LPMONIKER pmk);
   void OnSave(void);
   void OnClose(void);
   void OnLinkSrcChange(LPMONIKER pmk);
private:
   CAswRefHolder              m_refhIDataObject;
   CAswDataSiteListHead       m_lhListOfDataSites;
   PASWCONTAINEDOBJECT const  m_pAswContainedObject;
   BOOL                       m_bFullySetup;
};
#include <aspop.h>
#endif
