/* NOSHIP */
/*****************************************************************************
 *
 * aserror.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 *  Aswan (Lotus OLE/2) Error code macros and definitions
 *
 * List of classes in this file:
 *
 *    CAswOleResult
 *
 *****************************************************************************/

#if !defined (_ASWERROR_H)
#define _ASWERROR_H
#include <aspack.h>
typedef UINT ASWDISP;
#define ASW_ERRVAL_MAX           0xffff
#define ASW_FACILITY_MAX         0xf
#define ASD_MAX                  0x7ff
#define FACILITY_ASWAN           9
#define ASWAN_SCODE(sev,code)    MAKE_SCODE(sev,FACILITY_ASWAN,code)
#define ASWSUCCEEDED(ar)         (ar).Succeeded()
#define ASWFAILED(ar)            (ar).Failed()
#define ASWERR_STRINGID(ar)      (ar).ErrVal()
#define ASWDISP_STRINGID(ar)     ((ar).Disp()+ASW_MINIMUM_DISPSTRINGID)
#define OLD_ASW_CALL_COM_METHOD(refHRESULT,riid,pInterface,MethodName,paramlist)\
   ASWCALL(#pInterface"->"#MethodName#paramlist);\
   refHRESULT = (pInterface) -> MethodName paramlist;\
   ASWRETURNH (refHRESULT);\
   if (FAILED(refHRESULT))\
   {\
     PASWCONTROL _pCtl = GetControl();\
     if (! (_pCtl -> COMErrorIsSet()))\
     {\
        ASWCODESEGSTRING(__szAswCOMMethodName, #MethodName);\
        _pCtl->SetCOMError(refHRESULT);\
        _pCtl->SetErrorIID( riid);\
        _pCtl->SetErrorMethodName( __szAswCOMMethodName );\
     }\
   }
#define ASW_CALL_COM_METHOD(refHRESULT,riid,pInterface,MethodName,paramlist)\
   ASWCALL(#pInterface"->"#MethodName#paramlist);\
   refHRESULT = (pInterface) -> MethodName paramlist;\
   ASWRETURNH (refHRESULT);\
   GetControl()->RecordCOMMethod( refHRESULT, #MethodName, riid );
#define OLD_ASW_CALL_COM_API(refHRESULT,APIName,paramlist)\
   ASWCALL(#APIName#paramlist);\
   refHRESULT = APIName paramlist;\
   ASWRETURNH (refHRESULT);\
   if (FAILED(refHRESULT))\
   {\
     PASWCONTROL _pCtl = GetControl();\
     if (! (_pCtl -> COMErrorIsSet()))\
     {\
        ASWCODESEGSTRING(__szAswCOMAPIName, #APIName);\
        _pCtl->SetCOMError(refHRESULT);\
        _pCtl->SetErrorAPIName( __szAswCOMAPIName );\
     }\
   }
#define ASW_CALL_COM_API(refHRESULT,APIName,paramlist)\
   ASWCALL(#APIName#paramlist);\
   refHRESULT = APIName paramlist;\
   ASWRETURNH (refHRESULT);\
   GetControl()->RecordCOMAPI( refHRESULT, #APIName );
#define OLD_ASW_CALL_COM_API_BOOL(refbool,APIName,paramlist)\
{\
 ASWCALL(#APIName#paramlist);\
 refbool=APIName paramlist;\
 ASWRETURNB(refbool);\
 if(!refbool)\
 {\
  HRESULT hr=ResultFromScode(S_FALSE);\
  PASWCONTROL _pCtl=GetControl();\
  if(!(_pCtl->COMErrorIsSet()))\
  {\
    ASWCODESEGSTRING(__szAswCOMAPIName,#APIName );\
    _pCtl->SetCOMError(hr);\
    _pCtl->SetErrorAPIName(__szAswCOMAPIName);\
  }\
 }\
}
#define ASW_CALL_COM_API_BOOL(refbool,APIName,paramlist)\
{\
 ASWCALL(#APIName#paramlist);\
 refbool=APIName paramlist;\
 ASWRETURNB(refbool);\
 if(!refbool)\
 {\
  GetControl()->RecordCOMAPI( ResultFromScode(S_FALSE), #APIName );\
 }\
}
class ASWPUBCLASS CAswResult : public CAswMemoryBase
{
public:
   inline CAswResult( void )
   {
   }
#ifndef _WIN32
   inline CAswResult( SCODE   sc,
                      ASWDISP disp )
   {
      Set( sc, disp ); 
   }
#endif
   inline CAswResult( HRESULT hr,
                      ASWDISP disp )
   {
      Set( GetScode( hr ), disp );
   }
   inline void Set( HRESULT hr,
                    ASWDISP disp )
   {
      SCODE sc = GetScode( hr );
      m_result = (SCODE)( (unsigned long) sc | ( (unsigned long) disp << 20 ) );
   };
#ifndef _WIN32
   inline void Set( SCODE   sc,
                    ASWDISP disp )
   {
      m_result = (SCODE)( (unsigned long) sc | ( (unsigned long) disp << 20 ) );
   }
#endif
   inline SCODE Scode( void )
   {
      return (   m_result & ~( (unsigned long) ASD_MAX << 20 ) );
   }
   inline ASWDISP Disp( void )
   {
      return ( (ASWDISP) ( ( (unsigned long) m_result >> 20 ) & ASD_MAX ) );
   }
   inline UINT ErrVal( void )
   {
      return ( (UINT) m_result & ASW_ERRVAL_MAX );
   }
   inline BOOL Succeeded( void )
   {
      return SUCCEEDED( m_result );
   }
   inline BOOL Failed( void )
   {
      return FAILED( m_result );
   }
private:
   SCODE m_result;      
};
#include <aspop.h>
#endif
