/* NOSHIP */
/*****************************************************************************
 *
 * asippres.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswInPlacePresSite
 *
 * Description:
 *
 *
 *
 *****************************************************************************/

#ifndef ASWAN_ASIPPRES_H
#define ASWAN_ASIPPRES_H
#include <aspack.h>
class ASWPUBCLASS CAswInPlacePresSite : public CAswPresSite
{
public:
   ASWPUBMETHOD CAswInPlacePresSite( PASWCONTROL pAswControl ); 
   ASWPUBMETHOD ~CAswInPlacePresSite( void ); 
   CAswResult ASWPUBMETHOD Setup( PASWCONTAINEDOBJECT pAswContainedObject,
                                  PASWOBJRENDDEV      pAswObjRendDev, 
                                  PASWFRAMEWINDOW     pAswFrameWindow,
                                  PASWDOCWINDOW       pAswDocWindow, 
                                  HWND                hWnd );
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   virtual CAswResult ASWPUBMETHOD Draw( LPRECTL lprcBoundsLogical, 
                                         HDC     hicTargetDev, 
                                         HDC     hdcDraw, 
                                         BOOL    fPrinting = FALSE,  
                                         DWORD   dwContinue = NULL,
                                         LPRECTL lprcWBoundsLogical = NULL );
   virtual void ASWPUBMETHOD InPlaceObjectRequestsNewPosition( LPCRECT lprcPosClientPixelsIn,
                                                               LPRECT  lprcPosClientPixelsOut ); 
   CAswResult ASWPUBMETHOD UpdatePosRect( const LPRECT lprcPositionClientPixels ); 
   CAswResult ASWPUBMETHOD UpdateClipRect( const LPRECT lprcClipClientPixels = NULL ); 
   virtual void ASWPUBMETHOD OnGetClipRect( LPRECT lprcClipClientPixels );
   CAswResult ASWPUBMETHOD Deactivate( void ); 
   virtual BOOL ASWPUBMETHOD AllowInPlaceActivation( void ); 
   inline void AllowInsideOutBehavior( BOOL fSupportInsideOut )
   {
      ASWMETHOD("AllowInsideOutBehavior", (CH_CLASS_CASWINPLACEPRESSITE));
      ASWENTRYF("fSupportInsideOut=%s", (ASWSTR, ASWSHOWTF(fSupportInsideOut)));
      m_fSupportInsideOut = fSupportInsideOut;
      ASWEXIT();
   }
   virtual BOOL ASWPUBMETHOD Scroll( SIZEL scrollExtentPixels );
   virtual void ASWPUBMETHOD OnInPlaceActivate(void);
   virtual void ASWPUBMETHOD OnUIActivate(void);
   virtual void ASWPUBMETHOD OnInPlaceDeactivate(void);
   virtual void ASWPUBMETHOD OnUIDeactivate(void);
   CAswResult ASWPUBMETHOD ChangeInPlaceWnd( HWND hWnd );
public:
   inline PASWFRAMEWINDOW GetFrameWindowObj( void ) const
   {
      return m_pAswFrameWindow;
   };
   inline PASWDOCWINDOW  GetDocWindowObj( void ) const
   {
      return m_pAswDocWindow;
   };
   inline HWND GetInPlaceWnd( void ) const
   {
      return m_hParentingWnd;
   }
   void OnWindowShutdown(void);
   BOOL IsUndoSupported( void );
   inline BOOL IsInsideOutActivationAllowed(void)
   {
      return m_fSupportInsideOut;
   }
private:
public:
   CAswListEl     m_leInPlacePresSiteListElement; 
private:
   PASWCONTAINEDOBJECT  m_pAswContainedObject;
   PASWOBJRENDDEV       m_pAswObjRendDev; 
   PASWFRAMEWINDOW      m_pAswFrameWindow;
   PASWDOCWINDOW        m_pAswDocWindow;
   HWND                 m_hParentingWnd;
   BOOL                 m_fSupportInsideOut;
};
MAKELISTHEADCLASS(CAswInPlacePresSite);
#include <aspop.h>
#endif      
