/* NOSHIP */
/*****************************************************************************
 *
 * asmalloc.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *
 *    Defines these classes:
 *
 *       CAswIMallocImpl
 *       CAswMalloc
 *
 *****************************************************************************/

#if !defined( ASMALLOC_H )
#define ASMALLOC_H
#include <aspack.h>
class ASWPUBCLASS CAswIMallocImpl : public CAswIMalloc
{
public:
   ASWPUBMETHOD CAswIMallocImpl( PASWCONTROL pCtl,
                    PASWCOMBASE pCOMBase,
                    PASWMALLOC  pAswMalloc );
   ASWPUBMETHOD ~CAswIMallocImpl( void );
   STDMETHOD_( void FAR*, Alloc)        (THIS_ ULONG cb);
   STDMETHOD_( void FAR*, Realloc)      (THIS_ void FAR* pv, ULONG cb);
   STDMETHOD_( void,      Free)         (THIS_ void FAR* pv);
   STDMETHOD_( ULONG,     GetSize)      (THIS_ void FAR* pv);
   STDMETHOD_( int,       DidAlloc)     (THIS_ void FAR* pv);
   STDMETHOD_( void,      HeapMinimize) (THIS);
private:
   PASWMALLOC      m_pAswMalloc;
};
typedef CAswIMallocImpl ASWPTR * PASWIMALLOCIMPL;
class ASWPUBCLASS CAswMalloc : public CAswCOMBase
{
public:
   ASWPUBMETHOD CAswMalloc(PASWCONTROL pControl, LPUNKNOWN lpUnknownOuter=NULL);
   ASWPUBMETHOD ~CAswMalloc( void );
   virtual CAswResult ASWPUBMETHOD Setup( void );
   virtual CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   virtual void FAR * Alloc       ( ULONG cb )                PURE;
   virtual void FAR * Realloc     ( void FAR * pv, ULONG cb ) PURE;
   virtual void       Free        ( void FAR * pv )           PURE;
   virtual ULONG      GetSize     ( void FAR * pv )           PURE;
   virtual int        DidAlloc    ( void FAR * pv )           PURE;
   virtual void       HeapMinimize( void )                    PURE;
   inline LPMALLOC GetIMallocPointer( void )
   {
      return ( & m_CAswIMallocImpl );
   }
private:
   ASWAN_DECLARATIONS( 1 );
   CAswIMallocImpl      m_CAswIMallocImpl;
};
#include <aspop.h>
#endif 
