/* NOSHIP */
/*****************************************************************************
 *
 * Source Module: asmemall.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Class: CAswObjectAlloc
 *
 * Description: Helpers form CAswMemoryBase
 *
 * Public methods:
 *
 *    STATIC METHODS FOR DEBUGGING
 *
 *****************************************************************************/

#ifndef ASMEMALL_H
#define ASMEMALL_H
#include <aspack.h>
#if defined(MAKEDLL) || defined(ASWDLL)
class CAswObjectAlloc
{
public:
   ASWPUBMETHOD CAswObjectAlloc( DWORD dwCookie = 0 );
   ASWPUBMETHOD ~CAswObjectAlloc( void );
   inline DWORD GetCookie( void ) const
   {
      return ( m_dwCookie );
   }
   virtual PASWVOID Alloc( size_t nSize,
                           DWORD dwCookie ) PURE;
   virtual void     Free ( PASWVOID p,
                           DWORD dwCookie ) PURE;
#ifndef __DEBUG_ALLOC__
   PASWVOID ASWPUBFUNC operator new( size_t cb );
   void     ASWPUBFUNC operator delete( PASWVOID p );
#else
   PASWVOID ASWPUBFUNC operator new( size_t cb, const char*, size_t );
   void     ASWPUBFUNC operator delete( PASWVOID p, const char*, size_t );
#endif
private:
   DWORD    m_dwCookie;
};
PASWOBJECTALLOC ASWPUBFUNC GetAswAlloc( void );
class CAswMemoryAllocator
{
public:
   inline CAswMemoryAllocator( void )
   {
      MarkEmpty();
   }
   inline ~CAswMemoryAllocator( void )
   {
      MarkEmpty();
   }
   inline BOOL IsMatch( const CAswTask & refTask ) const
   {
      return ( m_Task == refTask );
   }
   inline BOOL IsMatch( PASWOBJECTALLOC pObjectAllocator ) const
   {
      return ( pObjectAllocator == GetAllocator() );
   }
   inline BOOL IsEmpty( void ) const
   {
      return ( ! m_Task.IsValid() );
   }
   inline void MarkEmpty( void )
   {
      m_Task.Shutdown();
      m_pObjectAllocImpl = NULL;
   }
   inline void MarkUsed( PASWOBJECTALLOC pObjectAllocator )
   {
      m_Task.Setup();
      m_pObjectAllocImpl = pObjectAllocator;
   }
   inline PASWOBJECTALLOC GetAllocator( void ) const
   {
      return ( m_pObjectAllocImpl );
   }
#ifndef __DEBUG_ALLOC__   
   PASWVOID ASWPUBFUNC  operator new( size_t cb );
   void     ASWPUBFUNC  operator delete( PASWVOID p );
#else
   PASWVOID ASWPUBFUNC  operator new( size_t cb, const char*, size_t );
   void     ASWPUBFUNC  operator delete( PASWVOID p, const char*, size_t );
#endif
private:
   CAswTask m_Task;
   PASWOBJECTALLOC m_pObjectAllocImpl;
};
#endif   
#include <aspop.h>
#endif 
