/* NOSHIP */
/*****************************************************************************
 *
 * Source Module: asmembas.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Class: CAswMemoryBase
 *
 * Description: When MAKING the DLL, override the new and delete operators
 *              for objects derived from this class so that objects will be
 *              properly allocated and deleted in DLL context
 *
 *****************************************************************************/

#ifndef ASMEMBAS_H
#define ASMEMBAS_H
#include <aspack.h>
FORWARD_CLASS_REF( CAswMemoryBase,      MEMORYBASE );
FORWARD_CLASS_REF( CAswObjectAlloc,     OBJECTALLOC );
#if defined(MAKEDLL) || defined(ASWDLL)
class CAswMemoryAllocator;
typedef CAswMemoryAllocator * PASWMEMORYALLOCATOR;
typedef PASWMEMORYALLOCATOR * PTRTOPASWMEMORYALLOCATOR;
const UINT NUM_MEMORY_ALLOCORS = 8;
#endif
class ASWPUBCLASS CAswMemoryBase
{
public:
   inline CAswMemoryBase(void)
   {
   }
#if defined(MAKEDLL) || defined(ASWDLL)
public:
#ifndef __DEBUG_ALLOC__
   PASWVOID ASWPUBFUNC operator new( size_t cb );
   void     ASWPUBFUNC operator delete( PASWVOID p );
#else
   PASWVOID ASWPUBFUNC operator new( size_t cb, const char*,size_t );
   void     ASWPUBFUNC operator delete( PASWVOID p, const char*, size_t );
#endif
private:
   static void AddAllocator( PASWOBJECTALLOC pAlloc );
   static void RemoveAllocator( PASWOBJECTALLOC pAswObjectAllocator );
   static void AllocNewAllocators( UINT uiNewAllocators = NUM_MEMORY_ALLOCORS );
   friend PASWOBJECTALLOC ASWPUBFUNC GetAswAlloc( void );
   friend CAswObjectAlloc;
   static PTRTOPASWMEMORYALLOCATOR NEAR sm_pAllocators;
   static UINT NEAR sm_uiNumAllocators;
#endif      
};
#include <aspop.h>
#endif 
