/* NOSHIP */
/*****************************************************************************
 *
 * asprop.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswPropSet
 *
 * Description:
 *
 *
 *
 *****************************************************************************/

#ifndef ASWAN_ASPROP_H
#define ASWAN_ASPROP_H
#include <asuminfo.h>
#include <aspack.h>
typedef OLEUI_FMTID FAR * LPFORMATID;
class ASWPUBCLASS CAswDictionary;
typedef CAswDictionary ASWPTR * PASWDICTIONARY;
class ASWPUBCLASS CAswDictElement;
typedef CAswDictElement ASWPTR * PASWDICTELEMENT;
class ASWPUBCLASS CAswDictElementListHead;
typedef CAswDictElementListHead ASWPTR * PASWDICTELEMENTLISTHEAD;
class ASWPUBCLASS CAswPropSection;
typedef CAswPropSection ASWPTR * PASWPROPSECTION;
class ASWPUBCLASS CAswProperty;
typedef CAswProperty ASWPTR * PASWPROPERTY;
class ASWPUBCLASS CAswPropSectionListHead;
typedef CAswPropSectionListHead ASWPTR * PASWPROPSECTIONLISTHEAD;
class ASWPUBCLASS CAswPropertyListHead;
typedef CAswPropertyListHead ASWPTR * PASWPROPERTYLISTHEAD;
#define MAXDICTENTRYSIZE 256
typedef struct tagSECTIONHEADER
{
   DWORD       cbSection ;
   DWORD       cProperties ;  
} SECTIONHEADER, FAR *PSECTIONHEADER ;
typedef struct tagPROPERTYIDOFFSET
{
   DWORD       propertyID;
   DWORD       dwOffset;
} PROPERTYIDOFFSET, FAR * PPROPERTYIDOFFSET;
typedef struct tagPROPHEADER
{
   WORD        wByteOrder ;    
   WORD        wFormat ;       
   DWORD       dwOSVer ;       
   CLSID       clsID ;         
   DWORD       cSections ;     
} PROPHEADER, FAR *PPROPHEADER ;
typedef struct tagFORMATIDOFFSET
{
   GUID        formatID;
   DWORD       dwOffset;
} FORMATIDOFFSET, FAR * PFORMATIDOFFSET;
struct DICTENTRYHEADER
{
	DWORD dwPropID;
	DWORD cb;
};
struct DICTENTRY
{
	DICTENTRYHEADER hdr;
	char sz[MAXDICTENTRYSIZE];
};
class ASWPUBCLASS CAswDictElement : public CAswCtlBase
{
public:
   CAswDictElement(PASWCONTROL pControl);
    ~CAswDictElement(void);
   CAswResult   Setup( PASWDICTIONARY pAswDictionary ); 
   CAswResult   Shutdown( BOOL fEmergency = FALSE ); 
   inline PVOID GetpPropName()
   {
      return(m_PropName.GetOPAQUEPtr()); 
   };
   inline DWORD GetPropNameSize()
   {
      return(m_PropName.GetSize()); 
   };
   inline DWORD GetPropID()
   {
      return(m_dwPropID); 
   };
   BOOL Set( DWORD  dwPropID,        
		       LPVOID pPropName,       
             DWORD  cb);             
public:
   CAswListEl     m_leDictElementListElement; 
private:
   CAswOPAQUEString       m_PropName ;
   DWORD                  m_dwPropID ;
   PASWDICTIONARY         m_pAswDictionary;	
};
MAKELISTHEADCLASS(CAswDictElement);
class ASWPUBCLASS CAswDictionary : public CAswCtlBase
{
public:
   ASWPUBMETHOD CAswDictionary(PASWCONTROL pControl);
   ASWPUBMETHOD ~CAswDictionary(void);
   CAswResult  ASWPUBMETHOD Setup( void ); 
   CAswResult  ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE ); 
   void ASWPUBMETHOD DeleteAll( void ); 
   void ASWPUBMETHOD Delete   ( PVOID pDictionaryEntryName, DWORD cb); 
   CAswResult ASWPUBMETHOD Get ( LPDWORD pdwPropID,                  
                                 PVOID   pictionaryEntryName,        
                                 DWORD   cb);                        
   BOOL  ASWPUBMETHOD Set( DWORD  dwPropID,                    
                           PVOID  lpszDictionaryEntryName,     
                           DWORD  cb);                         
public:
   inline void AddDictElementToList(PASWDICTELEMENT pAswDictElement)
   {
      m_lhListOfDictElement.Insert( pAswDictElement );
      m_DictElementCount++;
   };
   inline void RemoveDictElementFromList(PASWDICTELEMENT pAswDictElement)
   {
      m_lhListOfDictElement.Remove( pAswDictElement );
      m_DictElementCount--;
   };
   inline PASWDICTELEMENT GetFirstDictElement( void )
   {
      return m_lhListOfDictElement.GetFirst();
   }
   inline PASWDICTELEMENT GetNextDictElement( void )
   {
      return m_lhListOfDictElement.GetNext();
   }
#if 0   
   inline PASWDICTELEMENT GetNthElement( WORD n )
   {
      return m_lhListOfDictElement.GetNext();
   }
#endif
   inline WORD GetDictElementCount( void)
   {
      return (m_DictElementCount);
   }
public:
private:
   CAswDictElementListHead m_lhListOfDictElement;
   WORD                    m_DictElementCount;
   BOOL					      m_fSetup;
};
class ASWPUBCLASS CAswProperty : public CAswCtlBase
{
public:
   CAswProperty(PASWCONTROL pControl);
   ~CAswProperty(void);
   CAswResult  Setup( PASWPROPSECTION pAswPropSection, DWORD dwPropID  ); 
   CAswResult  Shutdown( BOOL fEmergency = FALSE ); 
   inline DWORD GetPropID()
   {
      return(m_dwPropID); 
   };
   inline void SetPropID(DWORD dwPropID)
   {
      m_dwPropID = dwPropID; 
   };
   BOOL ReadFromStream( IStream* pStream );
   BOOL WriteToStream(  IStream* pStream );
   CAswResult Get ( PVOID pValue,    
                    DWORD *pType,    
                    DWORD  cb,       
                    DWORD *pcb );     
   BOOL Set ( DWORD dwPropID,       
              const PVOID pValue,   
              DWORD pType,          
              DWORD dwCBpVal);      
public:
   CAswListEl     m_lePropertyListElement; 
private:
   LPVOID               AllocValue(ULONG cb);
   void                 FreeValue();
   PASWPROPSECTION         m_pAswPropSection;
   DWORD                   m_dwPropID ;
   DWORD                   m_dwType ;
   LPVOID                  m_pValue ;
};
MAKELISTHEADCLASS(CAswProperty);
class ASWPUBCLASS CAswPropSection : public CAswCtlBase
{
public:
   CAswPropSection(PASWCONTROL pControl);
   ~CAswPropSection(void);
   CAswResult  Setup( PASWPROPSET pAswPropSet, CLSID FormatID ); 
   CAswResult  Shutdown( BOOL fEmergency = FALSE ); 
   BOOL ReadFromStream( IStream* pIStream, LARGE_INTEGER liPropSet );
   BOOL WriteToStream( IStream* pStream );
   BOOL ReadDictionaryFromStream ( IStream* pIStream );
   BOOL WriteDictionaryToStream( IStream* pIStream );
   void DeleteAll( void ); 
   void Delete   ( DWORD dwPropID); 
   CAswResult Get ( DWORD dwPropID,  
                    PVOID pValue,    
                    DWORD *pType,    
                    DWORD  cb,       
                    DWORD *pcb );     
   BOOL Set( DWORD dwPropID,  
             PVOID pValue,    
             DWORD Type,      
             DWORD cb);       
   BOOL SetDictionaryName( PVOID pName, DWORD cb );
   BOOL GetDictionaryName( PVOID pName, DWORD cb , LPDWORD pcb);
   BOOL SetDictionaryEntry( DWORD   dwPropId,    
                            PVOID    pName,      
                            DWORD    cb);        
   BOOL GetDictionaryEntry( LPDWORD  pdwPropId,         
                            PVOID    pName,             
                            DWORD    cb);               
   void DeleteDictionaryEntry(PVOID pName, DWORD cb);
   void DeleteDictionary( void );
public:
   inline CLSID GetFormatID ( void )
   {
      return m_FormatID;
   }
   inline void SetFormatID ( CLSID FormatID )
   {
      m_FormatID = FormatID;
   };
   inline void AddPropertyToList(PASWPROPERTY pAswProperty)
   {
      m_lhListOfProperty.Insert( pAswProperty );
      m_PropertyCount++;
   };
   inline void RemovePropertyFromList(PASWPROPERTY pAswProperty)
   {
      m_lhListOfProperty.Remove( pAswProperty );
      m_PropertyCount--;
   };
   inline PASWPROPERTY GetFirstProperty( void )
   {
      return m_lhListOfProperty.GetFirst();
   }
   inline PASWPROPERTY GetNextProperty( void )
   {
      return m_lhListOfProperty.GetNext();
   }
   inline WORD GetPropertyCount( void)
   {
      return (m_PropertyCount);
   }
   inline LPMALLOC GetIMallocPtr( void)
   {
      return (m_lpMalloc);
   }
public:
   CAswListEl     m_lePropSectionListElement; 
private:
   PASWPROPSET          m_pAswPropSet;
   CAswPropertyListHead m_lhListOfProperty;
   SECTIONHEADER        m_SectionHeader;
   CLSID                m_FormatID;
   WORD                 m_PropertyCount;
   CAswDictionary       m_dictionary;
   CAswOPAQUEString     m_SectionName;
   LPMALLOC m_lpMalloc;
};
MAKELISTHEADCLASS(CAswPropSection);
class ASWPUBCLASS CAswPropSet : public CAswCtlBase
{
public:
   ASWPUBMETHOD CAswPropSet( PASWCONTROL pControl); 
   ASWPUBMETHOD ~CAswPropSet(void); 
   CAswResult ASWPUBMETHOD Setup( CLSID clsID = GUID_NULL ); 
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE ); 
   BOOL ASWPUBMETHOD ReadFromStream( CAswStream* pAswStream );
   BOOL ASWPUBMETHOD ReadFromStream( IStream* pStream );
   BOOL ASWPUBMETHOD WriteToStream( CAswStream* pAswStream );
   BOOL ASWPUBMETHOD WriteToStream( IStream* pStream );
   void ASWPUBMETHOD DeleteAll( void ); 
   void ASWPUBMETHOD Delete( CLSID SectionID, 
                             DWORD dwPropID); 
   CAswResult ASWPUBMETHOD Get( CLSID SectionID, 
                                DWORD dwPropID,  
                                PVOID pValue,    
                                DWORD *pType,    
                                DWORD  cb,       
                                DWORD *pcb );    
   BOOL ASWPUBMETHOD Set( CLSID SectionID, 
                          DWORD dwPropID,  
                          PVOID pValue,    
                          DWORD Type,      
                          DWORD cb );   
   BOOL ASWPUBMETHOD SetDictionaryName( CLSID  SectionID,     
                                        PVOID  pDictName,     
                                        DWORD  cb);           
   BOOL ASWPUBMETHOD GetDictionaryName( CLSID  SectionID,  
                                        PVOID  pDictName,  
                                        DWORD   cb,         
                                        LPDWORD pcb);
   BOOL  ASWPUBMETHOD SetDictionaryEntry( CLSID  SectionID,    
                                          DWORD  dwPropId,     
                                          PVOID  pstrDictName, 
                                          DWORD  cb);
   BOOL  ASWPUBMETHOD GetDictionaryEntry( CLSID    SectionID,           
                                          LPDWORD  pdwPropId,            
                                          PVOID    pDictName,
                                          DWORD    cb);
   void  ASWPUBMETHOD DeleteDictionaryEntry(CLSID  SectionID, PVOID pDictEntryName, DWORD cb);
   void  ASWPUBMETHOD DeleteDictionary( CLSID  SectionID );       
   WORD  ASWPUBMETHOD GetByteOrder( void ) ;
   void  ASWPUBMETHOD SetFormatVersion( WORD wFmtVersion ) ;
   WORD  ASWPUBMETHOD GetFormatVersion( void ) ;
   void  ASWPUBMETHOD SetOSVersion( DWORD dwOSVer ) ;
   DWORD ASWPUBMETHOD GetOSVersion( void ) ;
public:
   inline void AddPropSectionToList(PASWPROPSECTION pAswPropSection)
   {
      m_lhListOfPropSection.Insert( pAswPropSection );
      m_SectionCount++;
   };
   inline void RemovePropSectionFromList(PASWPROPSECTION pAswPropSection)
   {
      m_lhListOfPropSection.Remove( pAswPropSection );
      m_SectionCount--;
   };
   inline PASWPROPSECTION GetFirstPropSection( void )
   {
      return m_lhListOfPropSection.GetFirst();
   }
   inline PASWPROPSECTION GetNextPropSection( void )
   {
      return m_lhListOfPropSection.GetNext();
   }
   inline WORD GetSectionCount( void)
   {
      return (m_SectionCount);
   }
private:
   BOOL         m_fSetup;
   PROPHEADER   m_PropertyHeader;
   WORD         m_SectionCount;
   CAswPropSectionListHead      m_lhListOfPropSection;
};
#include <aspop.h>
#endif      
