/* NOSHIP */
/*****************************************************************************
 *
 * aststorg.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *
 *    forward class definitions and typedefs for pointers for Storage
 *
 *
 *
 *****************************************************************************/

#if !defined( ASWAN_ASTSTORG_H )
#define ASWAN_ASTSTORG_H
#include <aspack.h>
FORWARD_CLASS_REF( CAswPropSet,            PROPSET );
FORWARD_CLASS_REF( CAswSummaryInfoPropSet, SUMMARYINFOPROPSET );
FORWARD_CLASS_REF( CAswRootStorageBase,    ROOTSTORAGEBASE );
FORWARD_CLASS_REF( CAswStream,             STREAM );
FORWARD_CLASS_REF( CAswStorage,            STORAGE );
FORWARD_CLASS_REF( CAswDocFileStorage,     DOCFILESTORAGE );
FORWARD_CLASS_REF( CAswBentoStorage,       BENTOSTORAGE );
#pragma warning(disable:4284 4705)
class ASWPUBCLASS CAswSmartOLEString : public CAswMemoryBase
{
public:
   inline CAswSmartOLEString( LPASWOLESTR OLEPtr = NULL )
      : m_OLEPtr( OLEPtr )
      , m_dwStatFlags ( STATFLAG_NONAME )
   {
   }
   inline CAswSmartOLEString( DWORD dwLen )
      : m_OLEPtr( NULL )
      , m_dwStatFlags( STATFLAG_DEFAULT )
   {
      Allocate( dwLen );
   }
   inline ~CAswSmartOLEString( void )
   {
      Deallocate();
   }
   inline void Deallocate( void );
   inline void Allocate( DWORD dwLen );
   inline CAswSmartOLEString & operator= ( LPASWOLESTR ptr )
   {
      Deallocate();
      m_dwStatFlags = STATFLAG_NONAME;
      m_OLEPtr = ptr;
      return ( *this );
   }
   inline CAswSmartOLEString & operator= ( LPASWCOLESTR ptr )
   {
      Deallocate();
      m_dwStatFlags = STATFLAG_NONAME;
      m_OLEPtr = (LPASWOLESTR) ptr;
      return ( *this );
   }
#if defined( _WIN32 ) && defined(OLE2ANSI)
   inline CAswSmartOLEString & operator= ( LPOLESTR ptr )
   {
      Deallocate();
      m_dwStatFlags = STATFLAG_NONAME;
      m_OLEPtr = (LPASWOLESTR) ptr;
      return ( *this );
   }
   inline CAswSmartOLEString & operator= ( LPCOLESTR ptr )
   {
      Deallocate();
      m_dwStatFlags = STATFLAG_NONAME;
      m_OLEPtr = (LPASWOLESTR) ptr;
      return ( *this );
   }
#endif
   inline ASWOLECHAR FAR & operator* ( void )
   {
      return ( *m_OLEPtr );
   }
   inline operator LPASWOLESTR ()
   {
      return ( m_OLEPtr );
   }
   inline operator LPASWCOLESTR () const
   {
      return ( m_OLEPtr );
   }
   inline LPASWOLESTR RelinquishOwnership( void )
   {
      LPASWOLESTR pOld = m_OLEPtr;
      m_OLEPtr = NULL;
      return ( pOld );
   }
   inline DWORD Length( void ) const
   {
      if ( m_OLEPtr )
         return ( ASWLSTRLENW( m_OLEPtr ) );
      else
         return ( 0 );
   }
   inline DWORD SizeofChar( void ) const
   {
      return ( sizeof( ASWOLECHAR ) );
   }
private:
   LPASWOLESTR  m_OLEPtr;
   DWORD        m_dwStatFlags;
   CAswSmartOLEString & operator=( const CAswSmartOLEString & );  
   CAswSmartOLEString            ( const CAswSmartOLEString & );  
};
FORWARD_CLASS_REF( CAswSmartOLEString,       SMARTOLESTRING );
#pragma warning(default:4284)
struct FARSTRUCT ASWSTATSTG : public CAswMemoryBase
{
public:
   CAswSmartOLEString pwcsName;  
   DWORD          type;
   ULARGE_INTEGER cbSize;
   FILETIME       mtime;
   FILETIME       ctime;
   FILETIME       atime;
   DWORD          grfMode;
   DWORD          grfLocksSupported;
   CLSID          clsid;
   DWORD          grfStateBits;
   DWORD          reserved;
   inline ASWSTATSTG( void );
   inline ~ASWSTATSTG( void )
   {
   }
   inline void Clean( void )
   {
      pwcsName.Deallocate();
      type = 0; 
      ULISet32( cbSize, 0 );
      mtime.dwLowDateTime = 0;
      mtime.dwHighDateTime = 0;
      ctime.dwLowDateTime = 0;
      ctime.dwHighDateTime = 0;
      atime.dwLowDateTime = 0;
      atime.dwHighDateTime = 0;
      grfMode = 0;
      grfLocksSupported = 0;
      grfStateBits = 0;
      reserved = 0;
   }
   inline
   ASWSTATSTG &
   operator= ( const ASWSTATSTG & SourceObject )
   {
      if ( this != &SourceObject )
         DoCopy( SourceObject );
      return ( *this );
   }
   inline
   ASWSTATSTG( const ASWSTATSTG & SourceObject )
   {
      DoCopy( SourceObject );
   }
   inline
   ASWSTATSTG &
   operator= ( const STATSTG & SourceObject )
   {
      DoCopy( SourceObject );
      return ( *this );
   }
   inline
   ASWSTATSTG( const STATSTG & SourceObject )
   {
      DoCopy( SourceObject );
   }
private:
   void ASWPUBMETHOD DoCopy( const ASWSTATSTG & SourceObject );
   void ASWPUBMETHOD DoCopy( const STATSTG & SourceObject );
};
inline ASWSTATSTG::ASWSTATSTG( void )
{
}
#pragma warning(default:4705)
typedef ASWSTATSTG FAR * PASWSTATSTG;
struct ASWSTGMEDUNION : public CAswMemoryBase
{
   DWORD          tymed;
   union
   {
      HANDLE         hGlobal;
      LPASWOLESTR    lpszFileName;
      PASWSTREAM     pAswStream;
      PASWSTORAGE    pAswStorage;
   };
   LPUNKNOWN      pUnkForRelease;
};
typedef ASWSTGMEDUNION FAR * PASWSTGMEDUNION;
struct DOCFILESTGCREATE : public CAswMemoryBase
{
    LPASWOLESTR lpstrName; 
    DWORD dwgrfMode;       
    DWORD dwReserved;      
};
typedef DOCFILESTGCREATE FAR * LPDOCFILESTGCREATE;
typedef DOCFILESTGCREATE       BENTOSTGCREATE;
typedef DOCFILESTGCREATE FAR * LPBENTOSTGCREATE;
struct DOCFILESTGOPEN : public CAswMemoryBase
{
    LPASWOLESTR lpstrName;          
    PASWSTORAGE pAswStgPriority;    
    DWORD dwgrfMode;                
    ASWSNB snbExclude;              
    DWORD dwReserved;               
};
typedef DOCFILESTGOPEN FAR * LPDOCFILESTGOPEN;
typedef DOCFILESTGOPEN       BENTOSTGOPEN;
typedef DOCFILESTGOPEN       FAR * LPBENTOSTGOPEN;
#define ALL_SHAREBITS (  STGM_SHARE_DENY_NONE  \
                       | STGM_SHARE_DENY_READ  \
                       | STGM_SHARE_DENY_WRITE \
                       | STGM_SHARE_EXCLUSIVE)
#define HAS_SHARE_FLAGS(grfMode) (0 != ((grfMode) & ALL_SHAREBITS))
#define ENFORCE_SHARE_FLAG(grfMode,flag)\
{\
 \
 \
 (grfMode) &= ~(ALL_SHAREBITS);\
 \
 (grfMode) |= flag;\
}
#define ENFORCE_SHARE_EXCLUSIVE(grfMode) ENFORCE_SHARE_FLAG((grfMode),STGM_SHARE_EXCLUSIVE)
#define ENFORCE_SHARE_DENY_NONE(grfMode) ENFORCE_SHARE_FLAG((grfMode),STGM_SHARE_DENY_NONE)
#define ENFORCE_SHARE_DENY_READ(grfMode) ENFORCE_SHARE_FLAG((grfMode),STGM_SHARE_DENY_READ)
#define ENFORCE_SHARE_DENY_WRITE(grfMode) ENFORCE_SHARE_FLAG((grfMode),STGM_SHARE_DENY_WRITE)
typedef HRESULT (FAR PASCAL *OPENROOTSTGFP)( LPASWCOLESTR lpstrName,
                                  LPSTORAGE lpRealStgPriority,
                                  DWORD dwgrfMode,
                                  ASWSNB snbExclude,
                                  DWORD dwReserved,
                                  LPSTORAGE FAR * lpStorage );
typedef HRESULT (FAR PASCAL *CREATEROOTSTGFP)( LPASWCOLESTR lpstrName,
                                    DWORD dwgrfMode,
                                    DWORD dwReserved,
                                    LPSTORAGE FAR * lpStorage );
typedef LPSTORAGE FAR * LPLPSTORAGE;
#include <aspop.h>
#endif      
