/* NOSHIP */
/*****************************************************************************
 *
 * Source Module: channels.i
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Purpose:       DEFINE_CHANNEL statements used to generate #defines for
 *                channel numbers, using \aswan\src\build\makedefs.  Could
 *                also be used (with appropriate #define macro defined before
 *                #include) to generate string constants for a resource file.
 *
 *****************************************************************************/

DEFINE_CHANNEL( CH_ALLCHANNELS,                      -1, "All Channels" )
DEFINE_CHANNEL( CH_UNUSED,                           -2, "Don't use this" )
DEFINE_CHANNEL( CH_UNSPECIFIED,                       0, "Unspecified" )
DEFINE_CHANNEL( CH_ERRORS,                            1, "Messages for failed status indications" )
DEFINE_CHANNEL( CH_ASSERTIONS,                        2, "Messages for assertion failures" )
DEFINE_CHANNEL( CH_WARNINGS,                          3, "Warning messages for developers" )
DEFINE_CHANNEL( CH_CLASS_ASWBASE,                    10, "Class CAswBase: all methods" )
DEFINE_CHANNEL( CH_CLASS_CTLBASE,                    11, "Class CAswCtlBase: all methods" )
DEFINE_CHANNEL( CH_CLASS_CONTROL,                    12, "Class CAswControl: all methods" )
DEFINE_CHANNEL( CH_CLASS_DEBUGBASE,                  13, "Class CAswDebugBase: all methods" )
DEFINE_CHANNEL( CH_CLASS_OBJCLASS,                   14, "Class CAswObjectClass: all methods" )
DEFINE_CHANNEL( CH_CLASS_OBJINST,                    15, "Class CAswObjectInstance: all methods" )
DEFINE_CHANNEL( CH_CLASS_CLSFAC,                     16, "Class CAswClassFactory: all methods" )
DEFINE_CHANNEL( CH_CLASS_ASREFH,                     17, "Class CAswRefHolder: all methods" )
DEFINE_CHANNEL( CH_CLASS_ASSTORAGE,                  18, "Class CAswStorage: all methods" )
DEFINE_CHANNEL( CH_CLASS_ASSTREAM,                   19, "Class CAswStream: all methods" )
DEFINE_CHANNEL( CH_CLASS_ASBENTO,                    20, "Class CAswBentoStorage: all methods" )
DEFINE_CHANNEL( CH_CLASS_ASDOCFILE,                  21, "Class CAswDocFileStorage: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWROOTCONTAINER,          22, "Class CAswRootContainer: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCONTAINER,              23, "Class CAswContainer: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCOMSITE,                24, "Class CAswCOMSite: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCONTAINEDOBJECT,        25, "Class CAswContainedObject: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWDATAMANAGER,            26, "Class CAswDataManager: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWASPECT,                 27, "Class CAswAspect: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWOBJRENDDEV,             28, "Class CAswObjRendDev: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWSITEUI,                 29, "Class CAswSiteUI: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWPRESSITE,               30, "Class CAswPresSite: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWINPLACEPRESSITE,        31, "Class CAswInPlacePresSite: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWDATASITE,               32, "Class CAswDataSite: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCACHEDATASITE,          33, "Class CAswCacheDataSite: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWSHUTDOWN,               34, "Class CAswShutdown: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCODATAMGR,              35, "Class CAswCODataMgr: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWASYNC,                  36, "Class CAswAsync: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWOLECLISITE,             37, "Class CAswOleClientSiteImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWOLEOBJECT,              38, "Class CAswOleObjectImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIENUMOLEVERBIMPL,       39, "Class CAswIEnumOLEVERBImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWENUMOLEVERB,            40, "Class CAswEnumOLEVERB: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWOLEINPLACESITE,         41, "Class CAswOleInPlaceSiteImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWPSTG,                   42, "Class CAswPersistStorageImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWWINDOWBASE,             43, "Class CAswWindowBase: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWFRAMEWINDOW,            44, "Class CAswFrameWindow: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWDOCWINDOW,              45, "Class CAswDocWindow: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCONTACCEL,              46, "Class CAswContAccel: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCONTMENU,               47, "Class CAswContMenu: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWSPACEBASE,              48, "Class CAswSpaceBase: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWMENUBASE,               49, "Class CAswMenuBase: all methods" )
DEFINE_CHANNEL( CH_CLASS_TKOLEINPLACEFRAME,          50, "Class TKOleInPlaceFrame: all methods" )
DEFINE_CHANNEL( CH_CLASS_TKOLEINPLACEUIWINDOW,       51, "Class TKOleInPlaceUIWindow: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWDATAOBJECTIMPL,         52, "Server implementation of IDataObject" )
DEFINE_CHANNEL( CH_CLASS_CASWPERSISTFILEIMPL,        53, "Server implementation of IPersistFile" )
DEFINE_CHANNEL( CH_CLASS_SERVMENU,                   54, "Class CAswServMenu: all methods" )
DEFINE_CHANNEL( CH_CLASS_SERVACCEL,                  55, "Class CAswServAccel: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIOLEUILINKCONTAINER,    56, "Class CAswIOleUILinkContainerImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWMALLOC,                 57, "Class CAswMalloc: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIMALLOCIMPL,            58, "Class CAswIMallocImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIPOBJECT,               59, "Class CAswIInPlaceObjectImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIPACTIVEOBJ,            60, "Class CAswIInPlaceActiveObjectImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCLIPDATA,               61, "Class CAswClipData: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWDRAGDATA,               62, "Class CAswDragData: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWCLIPBOARDSOURCE,        63, "Class CAswClipboardSource: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWDRAGSOURCE,             64, "Class CAswDragSource: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWSOURCEFORMATSET,        65, "Class CAswSourceFormatSet: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWTARGETFORMATSET,        66, "Class CAswTargetFormatSet: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIDROPSOURCEIMPL,        67, "Class CAswIDropSourceImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWDROPTARGET,             68, "Class CAswDropTarget: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWPASTETARGET,            69, "Class CAswPasteTarget: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIDROPTARGETIMPL,        70, "Class CAswIDropTargetImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWADVISESINKIMPL,         71, "Class CAswAdviseSinkImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWOLEHINTSIMPL,           72, "Class CAswOleHintsImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWOLEOPRESIZEIMPL,        73, "Class CAswOleOutOfPlaceResizeImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWRESIZE,                 74, "Class CAswResize: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWASYNCOBJ,               75, "Class CAswsyncObject: all methods" )
DEFINE_CHANNEL( CH_CLASS_SERVSPACE,                  76, "Class CAswServSpace: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWOBJECTDESCRIPTOR,       77, "Class CAswObjectDescriptor: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWTARGETFEEDBACK,         78, "Class CAswTargetFeedback: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWEXTERNALCONNECTIONIMPL, 79, "Class CAswExternalConnectionImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWDATAOBJECTHOLDER,       80, "Class CAswDataObjectHolder: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIDISPATCHBASE,          81, "Class CAswIDispatchBase: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIOLEITEMCONTAINERIMPL,  82, "Class CAswIOleItemContainerImpl: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWPSEUDOOBJECT,           83, "Class CAswPseudoObject: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWENUMSTORAGE,            84, "Class CAswEnumStorage: all methods" )
DEFINE_CHANNEL( CH_CLASS_CASWIOLEUILTSLINKCONTAINER, 85, "Class CAswIOleUILtsLinkContainerImpl: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWUILINKBASE,             86, "Class CAswUILinkBase: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWUILINKCONTAINER,        87, "Class CAswUILinkContainer: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWUIOLELINK,              88, "Class CAswUIOleLink: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWDICTELEMENT,            89, "Class CAswDictElement: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWDICTIONARY,             90, "Class CAswDictionary: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWPROPERTY,               91, "Class CAswProperty: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWPROPSECTION,            92, "Class CAswPropSection: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWPROPSET,                93, "Class CAswPropSet: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWSUMMARYINFOPROPSET,     94, "Class CAswSummaryInfoPropSet: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWCONNMGR,                95, "Class CAswConnMgr: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWAUTOCONNMGR,            96, "Class CAswAutoConnMgr: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWIIDMAPSTATE,            97, "Class CAswIIDMapState: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWROOTSTORAGEBASE,        98, "Class CAswRootStorageBase: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWEVENTSINK,              99, "Class CAswEventSink: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWSTDEVENTSINK,          100, "Class CAswStdEventSink: all methods")
DEFINE_CHANNEL( CH_CLASS_CASWIDISPATCHEVENTS,       101, "Class CAswIDispatchEventsImpl: all methods")
DEFINE_CHANNEL( CH_COMBASE_PRIMITIVES,              200, "CAswCOMBase Primitives" )
DEFINE_CHANNEL( CH_COMBASE_IUNKNOWN,                201, "CAswCOMBase IUnknown methods" )
DEFINE_CHANNEL( CH_OBJINST_IUNKNOWN,                202, "CAswObjInstance IUnknown methods" )
DEFINE_CHANNEL( CH_COMBASE_IIDMAP,                  203, "CAswCOMBase IID Map methods" )
DEFINE_CHANNEL( CH_COMBASE_INFO,                    204, "CAswCOMBase information" )
DEFINE_CHANNEL( CH_INTBASE_PRIMITIVES,              205, "CAswIntBase Primitives" )
DEFINE_CHANNEL( CH_REFHOLDER_SETREL,                206, "see ref holders get set/released" )
DEFINE_CHANNEL( CH_SERVER_REG,                      300, "Server object registration" )
DEFINE_CHANNEL( CH_SERVER_OBJ,                      301, "Server object creation/destruction" )
DEFINE_CHANNEL( CH_SERVER_VERB,                     302, "Server verb handling" )
DEFINE_CHANNEL( CH_SERVER_INPLACE,                  303, "Server in-place handling" )
DEFINE_CHANNEL( CH_SERVER_MENU,                     304, "Server in-place menu handling" )
DEFINE_CHANNEL( CH_SERVER_ACCEL,                    305, "Server in-place accel handling" )
DEFINE_CHANNEL( CH_SERVER_SPACE,                    306, "Server in-place space negotiation" )
DEFINE_CHANNEL( CH_OCX_CASWBASE,                    307, "OCX methods in CAswBase")
DEFINE_CHANNEL( CH_OCX_OTHER,                    	 308, "OCX methods in other classes")
DEFINE_CHANNEL( CH_MTCHACK,                         400, "mtc's test program" )
DEFINE_CHANNEL( CH_COSMO_OBJINST,                   401, "CCosmoObjectInstance" )
DEFINE_CHANNEL( CH_COSMO_OBJCLASS,                  402, "CCosmoObjectClass" )
DEFINE_CHANNEL( CH_COSMO_SERVSPACE,                 403, "CCosmoServSpace" )
DEFINE_CHANNEL( CH_JBHACK,                          666, "jb's test program" )
