/* NOSHIP */
/*****************************************************************************
 *
 * File: LSRERR.HPP
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Desc: Definitions of Error results from the registry
 *
 *****************************************************************************/

#if !defined(LSRERR_HPP)
#define LSRERR_HPP
#include "lsrdefs.hpp"
#if LSR_ENABLED
#include "lsrole.hpp"
#include <scode.h>
#include "lsierr.h"
#define LSI_ERR_EXCEPTION_BASE	3000
inline LSUSHORT	LSR_MakeExceptionCode( LSUSHORT nStat )
{
	return LSUSHORT(nStat + LSI_ERR_EXCEPTION_BASE);
}
#define FACILITY_LSR					0x0010		
#define FACILITY_LSI					0x0011
typedef HRESULT LSRESULT;
typedef SCODE	 LSSCODE;
#define LSR_NOERROR	NOERROR		
#define OLE_NOERROR	NOERROR		
#define	LSR_S_BASE	LSI_ERR_LAST
enum LSReStatusCodes
{
	LSR_S_FIRST = LSR_S_BASE,
	LSR_S_REG_UNIMPL,
	LSR_S_REG_UNREGISTERED,
	LSR_S_REG_NOGUIDMAP,
	LSR_S_REG_GUIDUNKNOWN,
	LSR_S_REG_ADTIDUNKNOWN,
	LSR_S_REG_NOTCONSTRUCTED,
	LSR_S_REG_MEMORY,
	LSR_S_REG_MEMBERNOTDEFINED,
	LSR_S_REG_BADTYPE,
	LSR_S_REG_NOCALLBACK,
	LSR_S_REG_NOTINITIALIZED,
	LSR_S_ADT_OBJECTALREADYSET,
	LSR_S_ADT_CALLBACKFAILED,
	LSR_S_ADT_PROPISREADONLY,
	LSR_S_VAL_BADVALTYPE,
	LSR_S_API_BADDATATYPE,
	LSR_S_API_BADARG,
	LSR_S_API_SERVICEFAILED,
	LSR_S_EVT_BADARGNUM,
	LSR_S_VAL_CANTCONVERT,
	LSR_S_VAL_ARRAYTOOBIG,
	LSR_S_SRV_NOLIBMGR,
	LSR_S_TI_LIBNOTLOADED,
	LSR_S_TI_PROCNOTFOUND,
	LSR_S_LAST
};
inline LSSCODE LSR_MakeScode( LSUSHORT nErr )
{
	return (LSSCODE) MAKE_SCODE(SEVERITY_ERROR, (nErr > LSR_S_BASE) ? FACILITY_LSR : FACILITY_LSI, nErr);
}
inline LSRESULT LSR_MakeResult( LSUSHORT nErr )
{
	if (LSI_SUCCESS == nErr)
	{
		return LSR_NOERROR;
	}
	return (LSRESULT) ResultFromScode( LSR_MakeScode(nErr) );
}
inline LSSCODE LSR_GetScode( LSRESULT hRes )
{
	return (LSSCODE) GetScode( hRes );
}
inline LSUSHORT LSR_GetErrCode( LSRESULT hRes )
{
	return (LSUSHORT) SCODE_CODE( LSR_GetScode( hRes ) );
}
inline LSUSHORT LSR_GetFacility( LSRESULT hRes )
{
	return (LSUSHORT) SCODE_FACILITY( LSR_GetScode( hRes ) );
}
inline LSBOOL LSR_IsSuccess( LSRESULT hr )
{
	return (LSBOOL) (LSI_SUCCESS == GetScode(hr));
}
inline LSBOOL LSR_IsFailure( LSRESULT hr )
{
	return (LSBOOL) (LSI_SUCCESS != GetScode(hr));
}
#endif
#endif
