/* NOSHIP */
/*****************************************************************************
 *
 * scodemsg.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    Goes with scodemsg.cpp which contains code to return
 *    back a meaningful string of information about an OLE scode.
 *
 *    Format of an OLE scode is 32 bit values layed out as follows:
 *
 *        3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
 *        1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
 *       +-+---------------------+-------+-------------------------------+
 *       |S|       Context       | Facil |               Code            |
 *       +-+---------------------+-------+-------------------------------+
 *
 *       where
 *
 *       S - is the severity code
 *          0 - Success
 *          1 - Error
 *
 *       Context - context info
 *
 *       Facility - is the facility code
 *
 *       Code - is the facility's status code
 *
 *****************************************************************************/

#ifndef SCODEMSG_H
#define SCODEMSG_H
#include <aspack.h>
#if defined (_WIN32)
LPSTR ASWPUBFUNC GetScodeMsg( SCODE sc );
#else
LPSTR ASWPUBFUNC ScodeMsg( SCODE sc );
#endif
LPSTR inline
ScodeMsg( HRESULT hr )
{
#if defined (_WIN32)
   return(GetScodeMsg(GetScode(hr)));
#else
   return(ScodeMsg(GetScode(hr)));
#endif
}
#include <aspop.h>
#endif 
