#include <iwindefs.h>
#ifdef IC_PM
/**********************************************************************/
/* Following are mappings for multimedia macros in OS2 PM             */
/**********************************************************************/
#define IMMMODE(val,x)        {val = (IMMDevice::Mode)(x);}
#define IMMFORMAT(val,x)      {val = (IMMAudioBuffer::Format)(x);}
#define IMMTIME(val,x)        {val = (IMMTime::Format)(x);}
#define IMMSETTIME(val,x)     {val=x;}
#define IMMSUCCESSCODE(val,x) {x>=3 ? val = IMMNotifyEvent::error : val =(IMMNotifyEvent::SuccessCode)(x);}
#define IMMCHANNEL(val,x)     {val=(IMMDevice::AudioChannel)(x);}
#define IMMSETCHANNEL(val,x)  {val=x;}
#define IMMCOMMAND(val,x)     {val=x;}   // TTD

#endif /* IC_PM */
#ifdef IC_WIN
#include <mmsystem.h>
#include <digitalv.h>
#define MM_MCIPASSDEVICE      6485
#define MMIO_MEDIATYPE_AUDIO  1  //Need to find the real value
#define MCI_TO_END            MCI_SEEK_TO_END
#define MCI_TO_START          MCI_SEEK_TO_START
#define CCHMAXPATH            260
#define MAX_PRODINFO          40
#define MCI_GAINING_USE       40
/**********************************************************************/
/* Following are mappings for multimedia macros in Windows NT         */
/**********************************************************************/
#define IMMMODE(val,x)                                                  \
                                  {                                     \
                                     switch (x) {                       \
                                      case MCI_MODE_STOP:               \
                                           val =  IMMDevice::stopped;   \
                                           break;                       \
                                      case MCI_MODE_PLAY:               \
                                           val =  IMMDevice::playing;   \
                                           break;                       \
                                      case MCI_MODE_RECORD:             \
                                           val =  IMMDevice::recording; \
                                           break;                       \
                                      case MCI_MODE_PAUSE:              \
                                           val =  IMMDevice::paused;    \
                                           break;                       \
                                      case MCI_MODE_SEEK:               \
                                           val =  IMMDevice::seeking;   \
                                           break;                       \
                                      case MCI_MODE_NOT_READY:          \
                                      default:                          \
                                           val =  IMMDevice::notReady;  \
                                           break;                       \
                                     }                                  \
                                     }
#define IMMFORMAT(val,x)                                                \
                                  {                                     \
                                     switch (x) {                       \
                                      case WAVE_FORMAT_PCM:             \
                                      default:                          \
                                           val =IMMAudioBuffer::pcm;    \
                                           break;                       \
                                     }                                  \
                                     }

#define IMMCOMMAND(val,x)         {                                                    \
                                     switch (x) {                                      \
                                     case MCI_OPEN:                                    \
                                        val = IMMNotifyEvent::open ;                   \
                                        break;                                         \
                                     case MCI_CLOSE:                                   \
                                        val = IMMNotifyEvent::close ;                  \
                                        break;                                         \
                                     case MCI_ESCAPE:                                  \
                                        val = IMMNotifyEvent::escape ;                 \
                                        break;                                         \
                                     case MCI_PLAY:                                    \
                                        val = IMMNotifyEvent::play ;                   \
                                        break;                                         \
                                     case MCI_SEEK:                                    \
                                        val = IMMNotifyEvent::seek ;                   \
                                        break;                                         \
                                     case MCI_STOP:                                    \
                                        val = IMMNotifyEvent::stop ;                   \
                                        break;                                         \
                                     case MCI_PAUSE:                                   \
                                        val = IMMNotifyEvent::pause ;                  \
                                        break;                                         \
                                     case MCI_INFO:                                    \
                                        val = IMMNotifyEvent::info ;                   \
                                        break;                                         \
                                     case MCI_GETDEVCAPS:                              \
                                        val = IMMNotifyEvent::getDeviceCapabilities ;  \
                                        break;                                         \
                                     case MCI_SPIN:                                    \
                                        val = IMMNotifyEvent::spin ;                   \
                                        break;                                         \
                                     case MCI_SET:                                     \
                                        val = IMMNotifyEvent::set ;                    \
                                        break;                                         \
                                     case MCI_STEP:                                    \
                                        val = IMMNotifyEvent::step ;                   \
                                        break;                                         \
                                     case MCI_RECORD:                                  \
                                        val = IMMNotifyEvent::record ;                 \
                                        break;                                         \
                                     case MCI_SYSINFO:                                 \
                                        val = IMMNotifyEvent::sysInfo ;                \
                                        break;                                         \
                                     case MCI_BREAK:                                   \
                                        val = IMMNotifyEvent::breakCommand ;           \
                                        break;                                         \
                                     case MCI_SAVE:                                    \
                                        val = IMMNotifyEvent::save ;                   \
                                        break;                                         \
                                     case MCI_STATUS:                                  \
                                        val = IMMNotifyEvent::status ;                 \
                                        break;                                         \
                                     case MCI_CUE:                                     \
                                        val = IMMNotifyEvent::cue ;                    \
                                        break;                                         \
                                     case MCI_REALIZE:                                 \
                                        val = IMMNotifyEvent::realize ;                \
                                        break;                                         \
                                     case MCI_WINDOW:                                  \
                                        val = IMMNotifyEvent::windowCommand ;          \
                                        break;                                         \
                                     case MCI_PUT:                                     \
                                        val = IMMNotifyEvent::put ;                    \
                                        break;                                         \
                                     case MCI_WHERE:                                   \
                                        val = IMMNotifyEvent::where ;                  \
                                        break;                                         \
                                     case MCI_FREEZE:                                  \
                                        val = IMMNotifyEvent::freeze ;                 \
                                        break;                                         \
                                     case MCI_UNFREEZE:                                \
                                        val = IMMNotifyEvent::unfreeze ;               \
                                        break;                                         \
                                     case MCI_LOAD:                                    \
                                        val = IMMNotifyEvent::load ;                   \
                                        break;                                         \
                                     case MCI_CUT:                                     \
                                        val = IMMNotifyEvent::cut ;                    \
                                        break;                                         \
                                     case MCI_COPY:                                    \
                                        val = IMMNotifyEvent::copy ;                   \
                                        break;                                         \
                                     case MCI_PASTE:                                   \
                                        val = IMMNotifyEvent::paste ;                  \
                                        break;                                         \
                                     case MCI_UPDATE:                                  \
                                        val = IMMNotifyEvent::update ;                 \
                                        break;                                         \
                                     case MCI_RESUME:                                  \
                                        val = IMMNotifyEvent::resume ;                 \
                                        break;                                         \
                                     case MCI_DELETE:                                  \
                                        val = IMMNotifyEvent::deleteCommand ;          \
                                        break;                                         \
                                     case MCI_CAPTURE :                                \
                                        val = IMMNotifyEvent::capture ;                \
                                        break;                                         \
                                     case MCI_MONITOR :                                \
                                        val = IMMNotifyEvent::monitor ;                \
                                        break;                                         \
                                     case MCI_RESERVE :                                \
                                        val = IMMNotifyEvent::reserve ;                \
                                        break;                                         \
                                     case MCI_SETAUDIO:                                \
                                        val = IMMNotifyEvent::setAudioCommand ;        \
                                        break;                                         \
                                     case MCI_SIGNAL  :                                \
                                        val = IMMNotifyEvent::signal ;                 \
                                        break;                                         \
                                     case MCI_SETVIDEO:                                \
                                        val = IMMNotifyEvent::setVideoCommand ;        \
                                        break;                                         \
                                     case MCI_QUALITY :                                \
                                        val = IMMNotifyEvent::qualityCommand ;         \
                                        break;                                         \
                                     case MCI_LIST    :                                \
                                        val = IMMNotifyEvent::listCommand ;            \
                                        break;                                         \
                                     case MCI_UNDO    :                                \
                                        val = IMMNotifyEvent::undo ;                   \
                                        break;                                         \
                                     case MCI_CONFIGURE:                               \
                                        val = IMMNotifyEvent::configureCommand ;       \
                                        break;                                         \
                                     case MCI_RESTORE :                                \
                                        val = IMMNotifyEvent::restore ;                \
                                        break;                                         \
                                     default:                                          \
                                        val = IMMNotifyEvent::unknownCommand ;         \
                                        break;                                         \
                                     }                                                 \
                                  }

#define IMMTIME(val,x)                                                         \
                                  {                                            \
                                     switch (x) {                              \
                                      case MCI_FORMAT_MILLISECONDS:            \
                                           val = IMMTime::milliseconds;        \
                                           break;                              \
                                      case MCI_FORMAT_MSF:                     \
                                           val = IMMTime::minSecFrame;         \
                                           break;                              \
                                      case MCI_FORMAT_TMSF:                    \
                                           val = IMMTime::trackMinSecFrame;    \
                                           break;                              \
                                      case MCI_FORMAT_FRAMES:                  \
                                           val = IMMTime::frames;              \
                                           break;                              \
                                      case MCI_FORMAT_HMS:                     \
                                           val = IMMTime::hourMinSec;          \
                                           break;                              \
                                      case MCI_FORMAT_BYTES:                   \
                                           val = IMMTime::bytes;               \
                                           break;                              \
                                      case MCI_FORMAT_SAMPLES:                 \
                                           val = IMMTime::samples;             \
                                           break;                              \
                                      case MCI_FORMAT_SMPTE_24:                \
                                           val = IMMTime::mm24FramesPerSecond; \
                                           break;                              \
                                      case MCI_FORMAT_SMPTE_25:                \
                                           val = IMMTime::mm25FramesPerSecond; \
                                           break;                              \
                                      case MCI_FORMAT_SMPTE_30:                \
                                           val = IMMTime::mm30FramesPerSecond; \
                                           break;                              \
                                      case MCI_FORMAT_SMPTE_30DROP:            \
                                           val = IMMTime::mm30FramesPerSecondDrop; \
                                           break;                              \
                                      case MCI_SEQ_FORMAT_SONGPTR:             \
                                           val = IMMTime::songpointer;         \
                                           break;                              \
                                      default:                                 \
                                           val = IMMTime::milliseconds;        \
                                           break;                              \
                                     }                                         \
                                     }
   /********************************************************************|
   | MMPM's mmtime (Universal Chinatown Time) is not supported in Win32 |
   | For Win32, IMMTime::mmTime maps to IMMTime::milliseconds           |
   |********************************************************************/
#define IMMSETTIME(val,x)                                                     \
                                  {                                           \
                                     switch (x) {                             \
                                      case IMMTime::milliseconds:             \
                                           val = MCI_FORMAT_MILLISECONDS;     \
                                           break;                             \
                                      case IMMTime::mmTime:                   \
                                           val = MCI_FORMAT_MILLISECONDS;     \
                                           break;                             \
                                      case IMMTime::minSecFrame:              \
                                           val = MCI_FORMAT_MSF;              \
                                           break;                             \
                                      case IMMTime::trackMinSecFrame:         \
                                           val = MCI_FORMAT_TMSF;             \
                                           break;                             \
                                      case IMMTime::frames:                   \
                                           val = MCI_FORMAT_FRAMES;           \
                                           break;                             \
                                      case IMMTime::hourMinSec:               \
                                           val = MCI_FORMAT_HMS;              \
                                           break;                             \
                                      case IMMTime::bytes:                    \
                                           val = MCI_FORMAT_BYTES;            \
                                           break;                             \
                                      case IMMTime::samples:                  \
                                           val = MCI_FORMAT_SAMPLES;          \
                                           break;                             \
                                      case IMMTime::mm24FramesPerSecond:      \
                                           val = MCI_FORMAT_SMPTE_24;         \
                                           break;                             \
                                      case IMMTime::mm25FramesPerSecond:      \
                                           val = MCI_FORMAT_SMPTE_25;         \
                                           break;                             \
                                      case IMMTime::mm30FramesPerSecond:      \
                                           val = MCI_FORMAT_SMPTE_30;         \
                                           break;                             \
                                      case IMMTime::mm30FramesPerSecondDrop:  \
                                           val = MCI_FORMAT_SMPTE_30DROP;     \
                                           break;                             \
                                      case IMMTime::songpointer:              \
                                           val = MCI_SEQ_FORMAT_SONGPTR;      \
                                           break;                             \
                                      default:                                \
                                           val = MCI_FORMAT_MILLISECONDS;     \
                                           break;                             \
                                     }                                        \
                                     }
#define IMMSUCCESSCODE(val,x)                                                  \
                                  {                                            \
                                     switch (x) {                              \
                                      case MCI_NOTIFY_ABORTED:                 \
                                           val = IMMNotifyEvent::aborted;      \
                                           break;                              \
                                      case MCI_NOTIFY_SUCCESSFUL:              \
                                           val = IMMNotifyEvent::successful;   \
                                           break;                              \
                                      case MCI_NOTIFY_SUPERSEDED:              \
                                           val = IMMNotifyEvent::preempted;    \
                                           break;                              \
                                      case MCI_NOTIFY_FAILURE:                 \
                                      default:                                 \
                                           val = IMMNotifyEvent::error;        \
                                           break;                              \
                                     }                                         \
                                     val;}
#define IMMSETCHANNEL(val,x)                                           \
                                  {                                    \
                                     switch (x) {                      \
                                      case IMMDevice::left:            \
                                           val =  MCI_SET_AUDIO_LEFT;  \
                                           break;                      \
                                      case IMMDevice::right:           \
                                           val =  MCI_SET_AUDIO_RIGHT; \
                                           break;                      \
                                      case IMMDevice::all:             \
                                      default:                         \
                                           val =  MCI_SET_AUDIO_ALL;   \
                                           break;                      \
                                     }                                 \
                                     val;}
#define IMMCHANNEL(val,x)                                            \
                                  {                                  \
                                     switch (x) {                    \
                                      case MCI_SET_AUDIO_LEFT:       \
                                           val =  IMMDevice::left;   \
                                           break;                    \
                                      case MCI_SET_AUDIO_RIGHT:      \
                                           val =  IMMDevice::right;  \
                                           break;                    \
                                      case MCI_SET_AUDIO_ALL:        \
                                      default:                       \
                                           val =  IMMDevice::all;    \
                                           break;                    \
                                     }                               \
                                     val;}

/*********************************************************************/
/*                                                                   */
/*  Time format conversions macros                                   */
/*                                                                   */
/*********************************************************************/
#define MSECTOMM(value)      (((value) > (0xFFFFFFFF /3)) ? 0L : \
                              ((value) * 3))

#define MSECFROMMM(value)    (((value)+1) / 3)

#define REDBOOKTOMM(value)   ((((value) & 0x000000FF) * 60 * 3000) + \
                              (((value) & 0x0000FF00) / 0x100 * 3000) + \
                              (((value) & 0x00FF0000) / 0x10000 * 3000/75))

#define FPS24TOMM(value) ((((value) & 0x000000FF) * 60 * 60 * 3000) + \
                          (((value) & 0x0000FF00) / 0x100 * 60 * 3000) + \
                          (((value) & 0x00FF0000) / 0x10000 * 3000) + \
                          (((value) & 0xFF000000) / 0x1000000 * 3000/24))

#define FPS25TOMM(value) ((((value) & 0x000000FF) * 60 * 60 * 3000) + \
                          (((value) & 0x0000FF00) / 0x100 * 60 * 3000) + \
                          (((value) & 0x00FF0000) / 0x10000 * 3000) + \
                          (((value) & 0xFF000000) / 0x1000000 * 3000/25))

#define FPS30TOMM(value) ((((value) & 0x000000FF) * 60 * 60 * 3000) + \
                          (((value) & 0x0000FF00) / 0x100 * 60 * 3000) + \
                          (((value) & 0x00FF0000) / 0x10000 * 3000) + \
                          (((value) & 0xFF000000) / 0x1000000 * 3000/30))

#define HMSTOMM(value)   ((((value) & 0x000000FF) * 60 * 60 * 3000) + \
                          (((value) & 0x0000FF00) / 0x100 * 60 * 3000) + \
                          (((value) & 0x00FF0000) / 0x10000 * 3000))


  /* The +20 is used for rounding purposes.  It is derived by:           */
  /*   1/2 * ((300 MMTIME/SEC / (75 FRAMES/SEC)) = 20 MMTIME/HALF-FRAME  */
#define REDBOOKFROMMM(value) ((((value)+20) >= 0x100*60*3000) ? 0L : \
                              ((((value)+20) / (60*3000)) + \
                               (((value)+20) % (60*3000) / 3000 << 8) + \
                               (((value)+20) / (3000/75) % 75 << 16)))

#define FPS24FROMMM(value) ((((value)+63) >= 0x100*60*60*3000) ? 0L : \
                        (((((((value)+63) % 3000)/(3000/24)) << 24) & 0xFF000000) | \
                         ((((((value)+63) / 3000) % 60) << 16) & 0x00FF0000)      | \
                        (((((((value)+63) / 3000) / 60) % 60) << 8) & 0x0000FF00) | \
                         ((((((value)+63) / 3000) / 60) / 60)  & 0x000000FF)))

#define FPS25FROMMM(value) ((((value)+60) >= 0x100*60*60*3000) ? 0L : \
                        (((((((value)+60) % 3000)/(3000/25)) << 24) & 0xFF000000) | \
                         ((((((value)+60) / 3000) % 60) << 16) & 0x00FF0000)      | \
                        (((((((value)+60) / 3000) / 60) % 60) << 8) & 0x0000FF00) | \
                         ((((((value)+60) / 3000) / 60) / 60)  & 0x000000FF)))

#define FPS30FROMMM(value) ((((value)+50) >= 0x100*60*60*3000) ? 0L : \
                        (((((((value)+50) % 3000)/(3000/30)) << 24) & 0xFF000000) | \
                         ((((((value)+50) / 3000) % 60) << 16) & 0x00FF0000)      | \
                        (((((((value)+50) / 3000) / 60) % 60) << 8) & 0x0000FF00) | \
                         ((((((value)+50) / 3000) / 60) / 60)  & 0x000000FF)))

#define HMSFROMMM(value) ((((value)+50) >= 0x100*60*60*3000) ? 0L : \
                        (((((((value)+50) / 3000) % 60) << 16) & 0x00FF0000)      | \
                        (((((((value)+50) / 3000) / 60) % 60) << 8) & 0x0000FF00) | \
                         ((((((value)+50) / 3000) / 60) / 60)  & 0x000000FF)))

#define TMSF_TRACK(time)     (*(BYTE *)(&(time)))
#define TMSF_MINUTE(time)    (*((BYTE *)(&(time))+1))
#define TMSF_SECOND(time)    (*((BYTE *)(&(time))+2))
#define TMSF_FRAME(time)     (*((BYTE *)(&(time))+3))
#define MSF_MINUTE(time)     (*(BYTE *)(&(time)))
#define MSF_SECOND(time)     (*((BYTE *)(&(time))+1))
#define MSF_FRAME(time)      (*((BYTE *)(&(time))+2))

#endif /* IC_WIN */
