/* NOSHIP */
#ifndef _IDMCMDHR_
#define _IDMCMDHR_
/*******************************************************************************
* FILE NAME: idmcmdhdr.hpp                                                     *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMPopUpCommandHandler                                                   *
*     IDMPopUpMenuHandler                                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ipopmenu.hpp>
#include <imenuhdr.hpp>
#include <icmdhdr.hpp>

extern "C"
  {
  #define IUSING_OLE
  #ifdef WIN32_LEAN_AND_MEAN
    #undef WIN32_LEAN_AND_MEAN
  #endif
  #ifdef _OLE2_H_
    #undef _OLE2_H_
  #endif
  #include <iwindefs.h>
  }

#pragma pack(4)

#ifdef IC_WIN

class IDMPopUpMenuHandler : public IMenuHandler
{
public:
  IDMPopUpMenuHandler() ;
  virtual
    ~IDMPopUpMenuHandler() ;
protected:
virtual Boolean
  makePopUpMenu(IMenuEvent& menuEvent);
Boolean
  dispatchHandlerEvent(IEvent& evt);

public:
Boolean
  fNonDefaultDrag;
};

class IDMPopUpCommandHandler : public ICommandHandler
{
public:
  IDMPopUpCommandHandler() ;
  virtual
     ~IDMPopUpCommandHandler() ;
  void setPoint(POINTL pt);
  void setDataObject(IDataObject* dataObj);
protected:
virtual Boolean
  command(ICommandEvent& cmdEvent);
private:
  IDMPopUpCommandHandler ( const IDMPopUpCommandHandler&);
  IDMPopUpCommandHandler& operator=( const IDMPopUpCommandHandler&);

  POINTL point;
  IDataObject* dataObject;
};

#endif /* IC_WIN */

#pragma pack()

#endif //_IDMCMDHR_
