/* NOSHIP */
#ifndef _IGRAPHDR_
  #define _IGRAPHDR_
/*******************************************************************************
* FILE NAME: igraphdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IGraphicPushButtonHandler                                                *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ihandler.hpp>

#pragma pack(4)

// Forward declarations for other classes:
class IEvent;


class IGraphicPushButtonHandler : public IHandler {
typedef IHandler
  Inherited;
/*******************************************************************************
* Instances of the IGraphicPushButtonHandler class process the BM_SETHILITE    *
* event for IGraphicPushButtons.                                               *
*******************************************************************************/
public:
/*------------------------------- Constructor ----------------------------------
| The only way to construct instances of this class is to use the default      |
| constructor, which does not take any arguments.                              |
------------------------------------------------------------------------------*/
  IGraphicPushButtonHandler       ( );
virtual
 ~IGraphicPushButtonHandler       ( );

protected:
/*---------------------------- Event Dispatching -------------------------------
| This function evaluates the event to determine if it is appropriate for      |
| this handler object to process.                                              |
|   dispatchHandlerEvent - If it finds the BM_SETHILITE message, then it forces|
|                          a repaint of the graphic.  This function always     |
|                          returns false so that if there are any other        |
|                          handlers, they can process the messages.            |
------------------------------------------------------------------------------*/
virtual Boolean
  dispatchHandlerEvent ( IEvent& event );

private:
/*--------------------------------- Private ----------------------------------*/

}; // IGraphicPushButtonHandler


class IGraphicPushButtonData : public IBase {
/*******************************************************************************
* Private data for IGraphicPushButton.                                         *
*******************************************************************************/
public:
  IGraphicPushButtonData();
  ~IGraphicPushButtonData();

  Boolean fDrawDown;          // the button is pressed
};

#pragma pack()

#endif /* _IGRAPHDR_ */
