/*******************************************************************************
* FILE NAME: iwindow5.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of IWindow asString & asDebugInfo    *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
// Priority INT_MIN (-2147483647 - 1) + 1024 + 512
#pragma priority( -2147482112 )

extern "C" {
   #include <iwindefs.h>
}

#include <iwindow.hpp>
#include <iwinpriv.hpp>
#include <istring.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _IWINDOW5_CPP_
  #include <ipagetun.h>
#endif

/*------------------------------------------------------------------------------
| IWindow::asDebugInfo                                                         |
|                                                                              |
| Return debug information on the window.                                      |
------------------------------------------------------------------------------*/
IString IWindow::asDebugInfo() const
{
  IString str = asString();
  str += IString(", IHandler(") +
         IString((unsigned long)pWindowData->handlerList).d2x() +
         IString("), SubclassProc(") +
         IString((unsigned long)pWindowData->defaultProc).d2x() +
         IString(")");
  return str;
}

/*------------------------------------------------------------------------------
| IWindow::asString                                                            |
|                                                                              |
| Return some basic window information.                                        |
------------------------------------------------------------------------------*/
IString IWindow::asString() const
{

  IString str = IString("IWindowHandle(")+IString(
#ifdef IC_WIN
                         (unsigned long)(void*)(this->hwnd)
#else
                                                this->hwnd
#endif
                                                        ).d2x()+
                IString("), Id(")+IString(id())+IString(")");

  return str;
}
