/* NOSHIP */
#ifndef _IWINPRIV_INL_
#define _IWINPRIV_INL_ 0
/*******************************************************************************
* FILE NAME: iwinpriv.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in iwinpriv.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IWINPRIV_
  #undef  _IWINPRIV_INL_
  #define _IWINPRIV_INL_ 1
  #include <iwinpriv.hpp>
#endif

#include <ifont.hpp>

#if _IWINPRIV_INL_
  #define inline
#endif


/*------------------------------------------------------------------------------
| IWindowData::IWindowData                                                     |
------------------------------------------------------------------------------*/
inline IWindowData::IWindowData ( IWinProc*     windowProcedure,
                                  unsigned long defState )
       : defaultProc( windowProcedure )
       , state( defState )
       , layoutChange( 0 )
       , helpId( 0 )
       , ulExtGUIStyle( 0 )
       , handlerList( 0 )
       , minimumSize( -1, -1 )
#ifdef IC_PMWIN
       , fCachedMinimumSize( 0, 0 )
#endif
       , sizClChar( 0, 0 )
       , _observerData( 0 )
       , fHandlerRemovePending( false )
       , fSetMinSizeInProgress( false )
#ifdef IC_PMWIN
       , fAccelHandle( 0 )
#endif
#ifdef IC_WIN
       , fhwndOwner( 0 )
       , fFont( 0 )
       , lastButtonTime( 0 )
       , lastButtonEventHandle( 0 )
       , lastButtonEventId( 0 )
       , lastButtonPos( IPoint( 0, 0 ) )
       , eat_BN_CLICKED( false )
       , pointLButtonDown( 0, 0 )
       , bCheckingDragStart( false )
       , oldHeight( 0 )
       , oldWidth( 0 )
       , clrforeground( 0 )
       , clrbackground( 0 )
#endif
#ifdef IC_MOTIF
       // Motif Recoordination data members.
       , windowSize( ISize( 0, 0 ) )
       , windowPosition( IPoint( 0, 0 ) )
       , oldHeight( 0 )
       , oldWidth( 0 )
       , motifState( 0 )              // Motif-only data members.
       , windowOwner( 0 )
       , hwndTop( 0 )
       , gc( 0 )
       , gcUseCount( 0 )
#endif   // IC_MOTIF
{ }

/*------------------------------------------------------------------------------
| IWindowData::~IWindowData                                                    |
------------------------------------------------------------------------------*/
inline IWindowData::~IWindowData ( )
{
#ifdef IC_WIN
  if (fFont)
    delete fFont;
#endif
}

#endif // _IWINPRIV_INL_
